'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:59:09 am'!
Object subclass: #Compiler
	instanceVariableNames: 'sourceStream requestor class context forcePrivilage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
MessageNode subclass: #DynamicVariableNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
ParseNode subclass: #Encoder
	instanceVariableNames: 'scopeTable nTemps supered requestor class literalStream selectorSet litIndSet litSet sourceRanges globalSourceRanges allowDirectGlobalAccess '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
Scanner subclass: #Parser
	instanceVariableNames: 'here hereType hereMark prevToken prevMark encoder requestor parseNode failBlock requestorOffset tempsMark doitFlag class forcePrivilage '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
Behavior makeSelector: #ifScopeHas:doWithPoolName: privilaged: false!
!Behavior methodsFor: 'testing method dictionary' stamp: 'ls 5/25/2000 15:43'!
ifScopeHas: varName doWithPoolName: handlerBlock
	"Look up the first argument, varName, in the context of the receiver. If it is there, pass the name of the pool to the second argument, assocBlock, and answer true.  The 'name of the pool' will be the name of the class if it's a class variable, nil if it's a global variable, and the name of a pool if it's a variable in a shared pool"

	^superclass ifScopeHas: varName doWithPoolName: handlerBlock! !

Class makeSelector: #ifScopeHas:doWithPoolName: privilaged: false!
!Class methodsFor: 'compiling' stamp: 'ls 5/25/2000 15:51'!
ifScopeHas: varName doWithPoolName: handlerBlock
	"Look up the first argument, varName, in the context of the receiver. If it is there,
	pass the name of the pool to the second argument, assocBlock, and answer true.  The 'name of the pool' will be the name of the class if it's a class variable, nil if it's a global variable, and the name of a pool if it's a variable in a shared pool"

	| |
	"First look in classVar dictionary."
	(self classPool includesKey: varName) ifTrue: [
		handlerBlock value: self name.
		^true ].

	"Next look in shared pools."
	self sharedPools do: 
		[:pool | 
		(pool includesKey: varName) ifTrue: [
			handlerBlock value: (Smalltalk keyAtValue: pool).
			^true ] ].

	"look higher up the superclass chain and fail at the end."
	superclass == nil
		ifFalse: [^ superclass ifScopeHas: varName doWithPoolName: handlerBlock].

	"out of superclasses.  Check the global dictionary"
	(Smalltalk includesKey: varName) ifTrue: [
		handlerBlock value: nil.
		^true ].

	"the variable isn't visible"
	^false! !

Compiler makeSelector: #forcePrivilage privilaged: false!
!Compiler methodsFor: 'public access' stamp: 'ls 6/6/2000 11:20'!
forcePrivilage
	"compile methods with privilage, even if the relevant class marks the method as unprivilaged"
	forcePrivilage _ true! !
Compiler makeSelector: #from:class:context:notifying: privilaged: false!
!Compiler methodsFor: 'private' stamp: 'ls 6/6/2000 11:29'!
from: textOrStream class: aClass context: aContext notifying: req

	(textOrStream isKindOf: PositionableStream)
		ifTrue: [sourceStream _ textOrStream]
		ifFalse: [sourceStream _ ReadStream on: textOrStream asString].
	class _ aClass.
	context _ aContext.
	requestor _ req.
	forcePrivilage ifNil: [ forcePrivilage _ false ].! !

Metaclass makeSelector: #ifScopeHas:doWithPoolName: privilaged: false!
!Metaclass methodsFor: 'compiling' stamp: 'ls 5/25/2000 15:43'!
ifScopeHas: varName doWithPoolName: handlerBlock
	"Look up the first argument, varName, in the context of the receiver. If it is there, pass the name of the pool to the second argument, assocBlock, and answer true.  The 'name of the pool' will be the name of the class if it's a class variable, nil if it's a global variable, and the name of a pool if it's a variable in a shared pool"

	^thisClass ifScopeHas: varName doWithPoolName: handlerBlock! !

ParseNode makeSelector: #acceptsAssignments privilaged: false!
!ParseNode methodsFor: 'testing' stamp: 'ls 7/31/2000 18:44'!
acceptsAssignments
	"return whether this variable can have values stored into it"
	^false! !

AssignmentNode makeSelector: #variable:value:from: privilaged: false!
!AssignmentNode methodsFor: 'initialize-release' stamp: 'ls 5/25/2000 16:25'!
variable: aVariable value: expression from: encoder

	(aVariable isKindOf: MessageNode)
		ifTrue: ["Case of remote temp vars"
				^ aVariable store: expression from: encoder].
	variable _ aVariable.
	value _ expression! !

DynamicVariableNode makeSelector: #sizeForStorePop: privilaged: false!
!DynamicVariableNode methodsFor: 'as yet unclassified' stamp: 'ls 6/26/2000 15:18'!
sizeForStorePop: encoder
	^ self sizeForEffect: encoder! !
DynamicVariableNode makeSelector: #store:from: privilaged: false!
!DynamicVariableNode methodsFor: 'as yet unclassified' stamp: 'ls 8/3/2000 17:30'!
store: expression from: encoder
	"generate a node that can be used to store expression into this variable"
	^DynamicVariableNode new
		receiver: receiver
		selector: #setVariable:toValue:inPool:usingCache:
		arguments: {arguments first. expression.  arguments second. arguments third }
		precedence: 3
		from: encoder! !
DynamicVariableNode makeSelector: #asTranslatorNode privilaged: false!
!DynamicVariableNode methodsFor: 'C translation' stamp: 'ls 8/15/2000 10:17'!
asTranslatorNode
	^ TVariableNode new setName: arguments first key asString
! !

Encoder makeSelector: #beRestricted privilaged: false!
!Encoder methodsFor: 'initialize-release' stamp: 'ls 6/9/2000 12:13'!
beRestricted
	"restrict available variables and operations to what is available to untrusted code"
	||
	allowDirectGlobalAccess := false.
	scopeTable removeKey: 'thisContext'.
	#( blockCopy: class ) do: [ :selector |
		selectorSet removeKey: selector ].! !
Encoder makeSelector: #allowsDirectGlobalAccess privilaged: false!
!Encoder methodsFor: 'encoding' stamp: 'ls 7/28/2000 14:29'!
allowsDirectGlobalAccess
	"returns whether this encoder is allowing direct access to globals"
	^allowDirectGlobalAccess! !
Encoder makeSelector: #encodeLiteralWithoutSharing: privilaged: false!
!Encoder methodsFor: 'encoding' stamp: 'ls 7/6/2000 16:50'!
encodeLiteralWithoutSharing: object
	^LiteralNode new
		name: object
		key:  object
		index: nil
		type: LdLitType
! !
Encoder makeSelector: #encodeVariable:statically: privilaged: false!
!Encoder methodsFor: 'encoding' stamp: 'ls 7/28/2000 10:22'!
encodeVariable: name  statically: bindStatically
	^ self encodeVariable: name statically: bindStatically sourceRange: nil ifUnknown: [ self undeclared: name ]! !
Encoder makeSelector: #encodeVariable:statically:sourceRange:ifUnknown: privilaged: false!
!Encoder methodsFor: 'encoding' stamp: 'ls 7/28/2000 10:13'!
encodeVariable: name statically: bindStatically sourceRange: range ifUnknown: action
	| varNode |
	varNode _ scopeTable at: name
			ifAbsent: 
				[
					varNode := nil.
					bindStatically ifTrue: [
						"compile a direct reference to the global"
						(self lookupInPools: name 
							ifFound: [:assoc | varNode _ self global: assoc name: name]) ]
					ifFalse: [
						"compile a reference which goes via the currently active island"
						(self ifPoolsHave: name 
							doWithPoolName: [:poolName | varNode _ self poolVariable: name asSymbol inPoolNamed: poolName]) ].

					"if the variable wasn't found, perform the action"
					varNode ifNil: [ varNode := action value ]. ].

	name first isUppercase ifTrue:
		[globalSourceRanges addLast: { name. range. false }].
	^ varNode! !
Encoder makeSelector: #ifPoolsHave:doWithPoolName: privilaged: false!
!Encoder methodsFor: 'private' stamp: 'ls 5/25/2000 16:08'!
ifPoolsHave: varName doWithPoolName: handlerBlock

	Symbol hasInterned: varName ifTrue:
		[:sym | (class ifScopeHas: sym doWithPoolName: handlerBlock) ifTrue: [^ true]. ].

	^ class ifScopeHas: varName doWithPoolName: handlerBlock.  "Maybe a string in a pool  **Eliminate this**"! !
Encoder makeSelector: #islandNode privilaged: false!
!Encoder methodsFor: 'private' stamp: 'ls 5/25/2000 15:35'!
islandNode
	"return a node for obtaining the current island"
	| smalltalkNode methodNode |
	smalltalkNode := self global: (Smalltalk associationAt: #Smalltalk) name: 'Smalltalk'.
	methodNode := MessageNode new
		receiver: smalltalkNode
		selector: #currentIsland
		arguments: #()
		precedence: 1
		from: self.
	^methodNode! !
Encoder makeSelector: #poolVariable:inPoolNamed: privilaged: false!
!Encoder methodsFor: 'private' stamp: 'ls 7/6/2000 17:08'!
poolVariable: name inPoolNamed: poolName
	"return a node which will dynamically look up the given variable in the named pool"
	| nameNode poolNameNode messageNode smalltalkNode cacheNode |
	smalltalkNode := self global: (Smalltalk associationAt: #Smalltalk) name: 'Smalltalk'.
	nameNode := self encodeLiteral: name.
	poolName ifNil: [ poolNameNode := self encodeVariable: 'nil' ] ifNotNil: [ poolNameNode := self encodeLiteral: poolName ].
	cacheNode := self encodeLiteralWithoutSharing: (Array new: 1).

	messageNode := DynamicVariableNode new
		receiver: smalltalkNode
		selector: #valueOfVariable:inPool:usingCache:
		arguments: { nameNode. poolNameNode. cacheNode }
		precedence: 2
		from: self.

	^messageNode! !

MessageAsTempNode makeSelector: #acceptsAssignments privilaged: false!
!MessageAsTempNode methodsFor: 'testing' stamp: 'ls 7/31/2000 18:45'!
acceptsAssignments
	^true! !

Parser makeSelector: #forcePrivilage privilaged: false!
!Parser methodsFor: 'public access' stamp: 'ls 6/6/2000 11:29'!
forcePrivilage
	"parse the method with privilage, even if the class marks it as unprivilaged"
	forcePrivilage _ true.! !
Parser makeSelector: #variable: privilaged: false!
!Parser methodsFor: 'expression types' stamp: 'ls 8/1/2000 11:35'!
variable: bindStatically

	| varName varStart varEnd |
	(bindStatically and: [ encoder allowsDirectGlobalAccess not ]) ifTrue: [
		^self requiresPrivilage ].
	varStart _ self startOfNextToken + requestorOffset.
	varName _ self advance.
	varEnd _ self endOfLastToken + requestorOffset.
	^ encoder encodeVariable: varName
		statically: bindStatically
		sourceRange: (varStart to: varEnd)
		ifUnknown: [self correctVariable: varName interval: (varStart to: varEnd)]! !
Parser makeSelector: #requiresPrivilage privilaged: false!
!Parser methodsFor: 'error handling' stamp: 'ls 7/28/2000 14:41'!
requiresPrivilage
	"user has tried to do something that requires privilage.  Ultimately this should be implemented so that the invoking tool is informed and gets a chance to turn on privilage for this method"
	^self notify: 'permission denied'! !
Parser makeSelector: #init:notifying:failBlock: privilaged: false!
!Parser methodsFor: 'private' stamp: 'ls 6/6/2000 11:26'!
init: sourceStream notifying: req failBlock: aBlock
	forcePrivilage ifNil: [ forcePrivilage _ false ].
	requestor _ req.
	failBlock _ aBlock.
	super scan: sourceStream.
	prevMark _ hereMark _ mark.
	requestorOffset _ 0.
	self advance! !

PseudoClass makeSelector: #ifScopeHas:doWithPoolName: privilaged: false!
!PseudoClass methodsFor: 'testing method dictionary' stamp: 'ls 5/25/2000 15:44'!
ifScopeHas: varName doWithPoolName: handlerBlock
	handlerBlock value: varName.
	^ false! !

SystemDictionary makeSelector: #bindingForVariable:inPool:usingCache: privilaged: true!
!SystemDictionary methodsFor: 'islands' stamp: 'ls 8/14/2000 10:16'!
bindingForVariable: variableName inPool: poolName usingCache: cache
	"query the currently active island for the binding of the specified variable.  cache is a one-element array which can be used to implement a cache"
	"the current caching scheme is to store a 2-element array in cache whose first element is an island and whose second element is a binding.  The cache is valid as long as the island doesn't change: the assumption is that once a variable is given a binding on an island, that binding will never be replaced"
	| activeIsland cachedAssociation binding |
	activeIsland := self currentIsland.
	cachedAssociation := cache at: 1.
	cachedAssociation notNil ifTrue: [
		((cachedAssociation at: 1) == activeIsland) ifTrue: [
			"cache hit"
			binding := cachedAssociation at: 2.
			^binding ] ].

	"cache miss--look it up the hard way"
	binding := activeIsland associationForVariable: variableName inPool: poolName ifAbsent: [ nil ].
	binding ifNil: [ ^nil ].

	"put the binding in the cache"
	cache at: 1 put: (!!Array with: activeIsland with: binding).

	^binding! !
SystemDictionary makeSelector: #setVariable:toValue:inPool:usingCache: privilaged: false!
!SystemDictionary methodsFor: 'islands' stamp: 'ls 8/14/2000 13:48'!
setVariable: variableName toValue: value inPool: poolName usingCache: cache
	"query the currently active island for the value of the specified variable.  cache is a one-element array which can be used to implement a cache"
	| binding |
	binding := self bindingForVariable: variableName inPool: poolName usingCache: cache.
	binding ifNil: [ ^self error: 'no variable ', variableName, ' in pool ', poolName asString ].
	binding value: value.
	^value! !
SystemDictionary makeSelector: #valueOfVariable:inPool:usingCache: privilaged: false!
!SystemDictionary methodsFor: 'islands' stamp: 'ls 8/14/2000 13:48'!
valueOfVariable: variableName inPool: poolName usingCache: cache
	"query the currently active island for the value of the specified variable.  cache is a one-element array which can be used to implement a cache"

	| binding |
	binding := self bindingForVariable: variableName inPool: poolName usingCache: cache.
	binding ifNil: [ ^nil ].
	^binding value
! !

VariableNode makeSelector: #acceptsAssignments privilaged: false!
!VariableNode methodsFor: 'testing' stamp: 'ls 7/31/2000 18:44'!
acceptsAssignments
	^true! !

Scanner subclass: #Parser
	instanceVariableNames: 'here hereType hereMark prevToken prevMark encoder requestor parseNode failBlock requestorOffset tempsMark doitFlag forcePrivilage class '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Compiler'!
