'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:59:05 am'!
BraceNode makeSelector: #sizeForValue: privilaged: false!
!BraceNode methodsFor: 'code generation' stamp: 'ls 8/11/2000 11:57'!
sizeForValue: encoder

	emitNode _ elements size <= 4
		ifTrue: ["Short form: Array braceWith: a with: b ... "
				MessageNode new
					receiver: (encoder encodeVariable: #Array statically: true)
					selector: (self selectorForShortForm: elements size)
					arguments: elements precedence: 3 from: encoder]
		ifFalse: ["Long form: (Array braceStream: N) nextPut: a; nextPut: b; ...; braceArray"
				CascadeNode new
					receiver: (MessageNode new
								receiver: (encoder encodeVariable: #Array statically: true)
								selector: #braceStream:
								arguments: (Array with: (encoder encodeLiteral: elements size))
								precedence: 3 from: encoder)
					messages: ((elements collect: [:elt | MessageNode new receiver: nil
														selector: #nextPut:
														arguments: (Array with: elt)
														precedence: 3 from: encoder])
								copyWith: (MessageNode new receiver: nil
														selector: #braceArray
														arguments: (Array new)
														precedence: 1 from: encoder))].
	^ emitNode sizeForValue: encoder! !

CCodeGenerator makeSelector: #addClass: privilaged: false!
!CCodeGenerator methodsFor: 'public' stamp: 'ls 6/6/2000 11:19'!
addClass: aClass 
	"Add the variables and methods of the given class to the code base."
	| source |
	self checkClassForNameConflicts: aClass.
	self addClassVarsFor: aClass.
	"ikp..."
	self addPoolVarsFor: aClass.
	variables addAll: aClass instVarNames.
	'Adding Class ' , aClass name , '...'
		displayProgressAt: Sensor cursorPoint
		from: 0
		to: aClass selectors size
		during: [:bar | aClass selectors
				doWithIndex: 
					[:sel :i | 
					bar value: i.
					source _ aClass sourceCodeAt: sel.
					self addMethod: ((Compiler new forcePrivilage;
							parse: source
							in: aClass
							notifying: nil)
							asTranslationMethodOfClass: self translationMethodClass)]]! !
CCodeGenerator makeSelector: #codeStringForPrimitives: privilaged: false!
!CCodeGenerator methodsFor: 'public' stamp: 'ls 6/6/2000 11:18'!
codeStringForPrimitives: classAndSelectorList 
	| sel aClass source s verbose meth methodList |
	self initialize.
	classAndSelectorList do: 
		[:classAndSelector | 
		aClass _ Smalltalk at: (classAndSelector at: 1).
		self addAllClassVarsFor: aClass.
"TPR - should pool vars also be added here?"

		"find the method in either the class or the metaclass"
		sel _ classAndSelector at: 2.
		(aClass includesSelector: sel)
			ifTrue: [source _ aClass sourceCodeAt: sel]
			ifFalse: [source _ aClass class sourceCodeAt: sel].

		"compile the method source and convert to a suitable translation 
		method "
		meth _ (Compiler new forcePrivilage;
					parse: source
					in: aClass
					notifying: nil)
					asTranslationMethodOfClass: self translationMethodClass.

		"if this method is supposed to be a primitive (rather than a helper 
		routine), add assorted prolog and epilog items"
		meth primitive > 0 ifTrue: [meth preparePrimitiveInClass: aClass].
		"for old-style array accessing: 
		meth covertToZeroBasedArrayReferences."
		meth replaceSizeMessages.
		self addMethod: meth].

	"method preparation"
	verbose _ false.
	self prepareMethods.
	verbose
		ifTrue: 
			[self printUnboundCallWarnings.
			self printUnboundVariableReferenceWarnings.
			Transcript cr].

	"code generation"
	self doInlining: true.
	s _ ReadWriteStream on: (String new: 1000).
	methodList _ methods asSortedCollection: [:m1 :m2 | m1 selector < m2 selector].
	self emitCHeaderForPrimitivesOn: s.
	self emitCVariablesOn: s.
	self emitCFunctionPrototypes: methodList on: s.
	methodList do: [:m | m emitCCodeOn: s generator: self].
	^ s contents! !

Compiler makeSelector: #parse:in:notifying:dialect: privilaged: false!
!Compiler methodsFor: 'public access' stamp: 'ls 6/22/2000 14:54'!
parse: textOrStream in: aClass notifying: req dialect: useDialect
	| parser |
	"Compile the argument, textOrStream, with respect to the class, aClass, 
	and answer the MethodNode that is the root of the resulting parse tree. 
	Notify the argument, req, if an error occurs. The failBlock is defaulted to 
	an empty block."

	self from: textOrStream class: aClass context: nil notifying: req.
	parser _  ((useDialect and: [Preferences printAlternateSyntax])
		ifTrue: [DialectParser]
		ifFalse: [Parser]) new.
	forcePrivilage ifTrue: [ parser forcePrivilage ].
	^parser
		parse: sourceStream
		class: class
		noPattern: false
		context: context
		notifying: requestor
		ifFail: []! !
Compiler makeSelector: #translate:noPattern:ifFail: privilaged: false!
!Compiler methodsFor: 'private' stamp: 'ls 6/6/2000 11:21'!
translate: aStream noPattern: noPattern ifFail: failBlock

	| tree parser |
	parser _ Parser new.
	forcePrivilage ifTrue: [ parser forcePrivilage ].
	tree _ 
		parser
			parse: aStream
			class: class
			noPattern: noPattern
			context: context
			notifying: requestor
			ifFail: [^failBlock value].
	^tree! !

Decompiler makeSelector: #send:super:numArgs: privilaged: false!
!Decompiler methodsFor: 'instruction decoding' stamp: 'ls 8/1/2000 12:20'!
send: selector super: superFlag numArgs: numArgs

	| args rcvr selNode msgNode |
	args _ Array new: numArgs.
	(numArgs to: 1 by: -1) do:
		[:i | args at: i put: stack removeLast].
	rcvr _ stack removeLast.
	superFlag ifTrue: [rcvr _ constructor codeSuper].
	(selector == #blockCopy: and: [self checkForBlock: rcvr])
		ifTrue: [ ^self ].

	selNode _ constructor codeAnySelector: selector.
	rcvr == CascadeFlag
		ifTrue:
			[msgNode _ self cascadedMessageSend: selector selectorNode: selNode rcvr: rcvr args: args]
		ifFalse:
			[(rcvr isBlock and: [ selector == #restrictedProxy ])
				ifTrue: [ msgNode _ rcvr ]
				ifFalse: [
					msgNode _ constructor
								codeMessage: rcvr
								selector: selNode
								arguments: args]. ].

	msgNode ifNotNil: [
		stack addLast: msgNode. ].! !

DynamicVariableNode makeSelector: #acceptsAssignments privilaged: false!
!DynamicVariableNode methodsFor: 'testing' stamp: 'ls 7/31/2000 18:49'!
acceptsAssignments
	^true! !

Encoder makeSelector: #init:context:notifying: privilaged: false!
!Encoder methodsFor: 'initialize-release' stamp: 'ls 6/14/2000 14:14'!
init: aClass context: aContext notifying: req
	| node homeNode indexNode |
	requestor _ req.
	class _ aClass.
	nTemps _ 0.
	supered _ false.
	self initScopeAndLiteralTables.
	allowDirectGlobalAccess _ true.

	class allInstVarNames doWithIndex: [ :variableName :index|
		node _ InstanceVariableNode new
					name: variableName
					index: index-1
					type: LdInstType.
		scopeTable at: variableName put: node].

	aContext == nil
		ifFalse: 
			[homeNode _ self bindTemp: 'homeContext'.
			"first temp = aContext passed as arg"

			aContext tempNames doWithIndex:
				[:variable :index | 
				indexNode _ self encodeLiteral: index.
				node _ MessageAsTempNode new
							receiver: homeNode
							selector: #tempAt:
							arguments: (Array with: indexNode)
							precedence: 3
							from: self.
				scopeTable at: variable put: node]].
	sourceRanges _ Dictionary new: 32.
	globalSourceRanges _ OrderedCollection new: 32.
! !
Encoder makeSelector: #encodeVariable: privilaged: false!
!Encoder methodsFor: 'encoding' stamp: 'ls 7/28/2000 14:53'!
encodeVariable: name
	^ self encodeVariable: name statically: false! !

Parser makeSelector: #parse:class:noPattern:context:notifying:ifFail: privilaged: false!
!Parser methodsFor: 'public access' stamp: 'ls 8/1/2000 11:33'!
parse: sourceStream class: class0 noPattern: noPattern context: ctxt notifying: req ifFail: aBlock 
	"Answer a MethodNode for the argument, sourceStream, that is the root of 
	a parse tree. Parsing is done with respect to the argument, class, to find 
	instance, class, and pool variables; and with respect to the argument, 
	ctxt, to find temporary variables. Errors in parsing are reported to the 
	argument, req, if not nil; otherwise aBlock is evaluated. The argument 
	noPattern is a Boolean that is true if the the sourceStream does not 
	contain a method header (i.e., for DoIts)."

	 | meth repeatNeeded myStream |
	myStream _ sourceStream.
	class _ class0.
	[repeatNeeded _ false.
	self init: myStream notifying: req failBlock: [^aBlock value].
	doitFlag _ noPattern.
	encoder _ Encoder new init: class context: ctxt notifying: self.
	failBlock_ aBlock.
	[meth _ self method: noPattern context: ctxt encoder: encoder] 
		on: ParserRemovedUnusedTemps 
		do: 
			[repeatNeeded _ true.
			myStream _ ReadStream on: requestor text string].
	repeatNeeded] whileTrue.

	^ meth! !
Parser makeSelector: #expression privilaged: false!
!Parser methodsFor: 'expression types' stamp: 'ls 8/1/2000 11:33'!
expression
	(hereType = #word or: [
		here = #!! and: [ tokenType = #word ]]) ifTrue:[
		"expression starts with a variable--maybe we have an assignment"
		here = #!!
			ifTrue: [ "hard-bind the variable"
				self advance.
				parseNode := self variable: true ]
			ifFalse: [ "soft-bind the variable"
				parseNode := self variable: false ].

		hereType == #leftArrow ifTrue: [
			"assignment statement"
			^self assignment: parseNode. ].

		"not assignment--check for def/ref"
		(parseNode isUndefTemp and: [self interactive])
			ifTrue: [self queryUndefined].		
		parseNode nowHasRef.
	]
	ifFalse: [
		"not a variable; get some other kind of primary expression"
		self primaryExpression ifFalse: [ ^false ]].

	"not an assignment--check for messages"
	(self messagePart: 3 repeat: true)
		ifTrue: [hereType == #semicolon ifTrue: [self cascade]].
	^ true! !
Parser makeSelector: #method:context:encoder: privilaged: false!
!Parser methodsFor: 'expression types' stamp: 'ls 6/14/2000 16:29'!
method: doit context: ctxt encoder: e
	" pattern [ | temporaries ] block => MethodNode."

	| sap blk prim temps messageComment methodNode allowPrimitive |
	sap _ self pattern: doit inContext: ctxt.
	"sap={selector, arguments, precedence}"
forcePrivilage ifNil: [ forcePrivilage _ false ].  "hack for the bootup process"

	
	(forcePrivilage not and: [(class selectorIsPrivilaged: (sap at: 1)) not]) 
		ifTrue: [ encoder beRestricted. allowPrimitive := false ]
		ifFalse: [ allowPrimitive := true ].

	(sap at: 2) do: [:argNode | argNode isArg: true].
	temps _ self temporaries.
	messageComment _ currentComment.
	currentComment _ nil.
	prim _ (doit or: [ allowPrimitive not ]) ifTrue: [0] ifFalse: [self primitive].
	self statements: #() innerBlock: doit.
	blk _ parseNode.
	doit ifTrue: [blk returnLast]
		ifFalse: [blk returnSelfIfNoOther].
	hereType == #doIt ifFalse: [^self expected: 'Nothing more'].
	self interactive ifTrue: [self removeUnusedTemps].
	methodNode _ MethodNode new comment: messageComment.
	^methodNode
		selector: (sap at: 1)
		arguments: (sap at: 2)
		precedence: (sap at: 3)
		temporaries: temps
		block: blk
		encoder: encoder
		primitive: prim
! !
Parser makeSelector: #primaryExpression privilaged: false!
!Parser methodsFor: 'expression types' stamp: 'ls 8/18/2000 15:34'!
primaryExpression 
	((hereType == #word)  or: [  (here == #!!) and: [ (tokenType == #word) ] ])
		ifTrue: 
			[
			"parse the variable expression"
			hereType == #word 
				ifTrue: [ "regular variable" 
					parseNode _ self variable: false ]
				ifFalse: [ "statically bound variable"  
					self advance.
					parseNode _ self variable: true ].

			"def/ref checks"
			(parseNode isUndefTemp and: [self interactive])
				ifTrue: [self queryUndefined].		
			parseNode nowHasRef.

			"leave the result in parseNode"
			^ true].

	hereType == #leftBracket
		ifTrue: 
			[self advance.
			self blockExpression.
			^true].
	hereType == #leftBrace
		ifTrue: 
			[self braceExpression.
			^true].
	hereType == #leftParenthesis
		ifTrue: 
			[self advance.
			self expression ifFalse: [^self expected: 'expression'].
			(self match: #rightParenthesis)
				ifFalse: [^self expected: 'right parenthesis'].
			^true].
	(hereType == #string or: [hereType == #number or: [hereType == #literal]])
		ifTrue: 
			[parseNode _ encoder encodeLiteral: self advance.
			^true].
	(here == #- and: [tokenType == #number])
		ifTrue: 
			[self advance.
			parseNode _ encoder encodeLiteral: self advance negated asReadOnlyNumber.
			^true].
	^false! !
Parser makeSelector: #variable: privilaged: false!
!Parser methodsFor: 'expression types' stamp: 'ls 8/1/2000 11:35'!
variable: bindStatically

	| varName varStart varEnd |
	(bindStatically and: [ encoder allowsDirectGlobalAccess not ]) ifTrue: [
		^self requiresPrivilage ].
	varStart _ self startOfNextToken + requestorOffset.
	varName _ self advance.
	varEnd _ self endOfLastToken + requestorOffset.
	^ encoder encodeVariable: varName
		statically: bindStatically
		sourceRange: (varStart to: varEnd)
		ifUnknown: [self correctVariable: varName interval: (varStart to: varEnd)]! !

