'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:27:33 am'!
"Change Set:		MorphicSandbox
Date:			13 August 2000
Author:			Lex Spoon

Includes a sandbox for loading and interacting with morphic projects"

Smalltalk at: #DisplayCanvas put: nil.
Smalltalk at: #InputEvents put: nil.!

Object subclass: #AAAMorphicSandboxReadme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!AAAMorphicSandboxReadme commentStamp: 'ls 8/15/2000 16:49' prior: 0!
XXX this is out of date.


This class category defines a sandbox that a morphic world can live in.  The central class is MorphicSandbox.  A MorphicSandbox maintains a bitmap virtual display, and has a queue of events.

Sandboxed code accesses a MorphicSandbox via instances of MorphicSandboxCanvas and MorphicSandboxSensor.


Overall, this is a simplistic design.  In particular, it would be nice if canvas commands were forwarded all the way to the canvas of the user-visible world, instead of maintaining a large bitmap.  At least, though, the exact mechanism used is invisible to the sandboxed world--it only sees a canvas and a sensor.
!
Object subclass: #DisplayScreenStandin
	instanceVariableNames: 'form '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!DisplayScreenStandin commentStamp: 'ls 8/14/2000 18:52' prior: 0!
A DisplayCanvas that isn't really.  This is to get Morphic working inside a sandbox.

Perhaps this should be merged with MorphicSandboxCanvas, so that Display and DisplayCanvas would be the same object?!
Object subclass: #MorphicSandbox
	instanceVariableNames: 'displayCanvas events display sandboxProcess mutex currentCursor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!MorphicSandbox commentStamp: 'ls 8/15/2000 17:08' prior: 0!
A MorphicSandbox maintains a bitmap virtual display, and has a queue of events.  All operations are guarded by a mutex, so that the object may be accessed from multiple threads.

Note: all instance variables point to objects *outside* the sandbox, and they are trusted to be in sane conditions.  

XXX - the display update cycle is not done properly.  There should really be *two* forms maintained.!
Canvas subclass: #MorphicSandboxCanvas
	instanceVariableNames: 'sandbox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!MorphicSandboxCanvas commentStamp: '<historical>' prior: 0!
A canvas accessible from a sandbox.  Drawing commands are forwarded to a MorphicSandbox.  !
Form subclass: #NonHibernatingForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Graphics-Display Objects'!
RestrictedProxy subclass: #ReallyRestrictedClass
	instanceVariableNames: 'class '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sandbox-Proxies'!
RestrictedProxy subclass: #SandboxCursorInstaller
	instanceVariableNames: 'sandbox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!
RestrictedProxy subclass: #SandboxEventSource
	instanceVariableNames: 'sandbox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!SandboxEventSource commentStamp: 'ls 8/15/2000 09:13' prior: 0!
An event source for the inside of a sandbox.  It has just one useful method, which returns events passed in from outside the sandbox.!
Morph subclass: #SandboxMorph
	instanceVariableNames: 'sandbox '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!

!SandboxMorph commentStamp: '<historical>' prior: 0!
A morph for interacting with a sandboxed world.!
Object subclass: #SensorStandin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Islands-Morphic'!
Object makeSelector: #safeBitmapFor: privilaged: true!
!Object methodsFor: 'safe conversion' stamp: 'ls 8/15/2000 16:55'!
safeBitmapFor: inputBitmap
	"returns a new bitmap with the same contents as the supplied bitmap"
	| retval |
	!!Processor doInSystemIsland: [
		(inputBitmap isKindOf: Bitmap) ifFalse: [
			^self error: 'expected a Bitmap' ].

		retval := Bitmap new: inputBitmap size.
		retval replaceFrom: 1 to: inputBitmap size with: inputBitmap startingAt: 1 ].

	^retval	! !
Object makeSelector: #safeCursorFor: privilaged: true!
!Object methodsFor: 'safe conversion' stamp: 'ls 8/15/2000 17:02'!
safeCursorFor: inputCursor
	| extent depth bits retval offset |
	extent := self safePointFor: inputCursor extent.

	depth := self safeIntegerFor: inputCursor depth.
	depth ~= 1 ifTrue: [ ^self error: 'cursors must have depth 1' ].

	offset := self safePointFor: inputCursor offset.
	(offset abs x > 16 or: [ offset abs y > 16 ]) ifTrue: [
		self error: 'offset too large' ].

	bits := self safeBitmapFor: inputCursor bits.

	!!Processor doInSystemIsland: [
		retval := Cursor basicNew setExtent: extent depth: depth bits: bits.
		retval offset: offset. ].

	^retval! !

ClassDescription makeSelector: #printMethodChunk:withPreamble:on:moveSource:toFile: privilaged: false!
!ClassDescription methodsFor: 'fileIn/Out' stamp: 'ls 6/5/2000 15:36'!
printMethodChunk: selector withPreamble: doPreamble on: outStream
		moveSource: moveSource toFile: fileIndex
	"Copy the source code for the method associated with selector onto the fileStream.  If moveSource true, then also set the source code pointer of the method."
	| preamble method oldPos newPos sourceFile endPos |
	"write out the privilage specification for the method"
	outStream nextChunkPut: (self name, ' makeSelector: ', selector storeString, ' privilaged: ', (self selectorIsPrivilaged: selector) storeString).

	doPreamble 
		ifTrue: [preamble _ self name , ' methodsFor: ' ,
					(self organization categoryOfElement: selector) asString printString]
		ifFalse: [preamble _ ''].
	method _ self methodDict at: selector.
	((method fileIndex = 0
		or: [(SourceFiles at: method fileIndex) == nil])
		or: [(oldPos _ method filePosition) = 0])
		ifTrue:
		["The source code is not accessible.  We must decompile..."
		preamble size > 0 ifTrue: [outStream cr; nextPut: $!!; nextChunkPut: preamble; cr].
		outStream nextChunkPut: (self decompilerClass new decompile: selector
											in: self method: method) decompileString]
		ifFalse:
		[sourceFile _ SourceFiles at: method fileIndex.
		sourceFile position: oldPos.
		preamble size > 0 ifTrue:    "Copy the preamble"
			[outStream copyPreamble: preamble from: sourceFile].
		"Copy the method chunk"
		newPos _ outStream position.
		outStream copyMethodChunkFrom: sourceFile.
		sourceFile skipSeparators.      "The following chunk may have ]style["
		sourceFile peek == $] ifTrue: [
			outStream cr; copyMethodChunkFrom: sourceFile].
		moveSource ifTrue:    "Set the new method source pointer"
			[endPos _ outStream position.
			method checkOKToAdd: endPos - newPos at: newPos.
			method setSourcePosition: newPos inFile: fileIndex]].
	preamble size > 0 ifTrue: [outStream nextChunkPut: ' '].
	^ outStream cr! !
ClassDescription makeSelector: #newInstanceFrom:variable:size:map: privilaged: false!
!ClassDescription methodsFor: 'private' stamp: 'ls 6/29/2000 15:35'!
newInstanceFrom: oldInstance variable: variable size: instSize map: map
	"Create a new instance of the receiver based on the given old instance.
	The supplied map contains a mapping of the old instVar names into
	the receiver's instVars"
	| new |
	variable
		ifTrue: [new _ self basicNew: oldInstance basicSize]
		ifFalse: [new _ self basicNew].
	1 to: instSize do: 
		[:offset |  (map at: offset) > 0 ifTrue:
			[ObjectInspector instVarOf: new at: offset
					put: (ObjectInspector instVarOf: oldInstance at: (map at: offset))]].
	variable 
		ifTrue: [1 to: oldInstance basicSize do: 
					[:offset |
					new basicAt: offset put: (oldInstance basicAt: offset)]].
	^new! !

Color makeSelector: #setHue:saturation:brightness: privilaged: false!
!Color methodsFor: 'private' stamp: 'ls 8/15/2000 19:36'!
setHue: hue saturation: saturation brightness: brightness
	"Initialize this color to the given hue, saturation, and brightness. See the comment in the instance creation method for details."

	| s v hf i f p q t | 
	s _ (saturation asFloat max: 0.0) min: 1.0.
	v _ (brightness asFloat max: 0.0) min: 1.0.

	"zero saturation yields gray with the given brightness"
	s = 0.0 ifTrue: [ ^ self setRed: v green: v blue: v ].

	hf _ hue asFloat.
	(hf < 0.0 or: [hf >= 360.0])
		ifTrue: [hf _ hf - ((hf quo: 360.0) asFloat * 360.0)].
	hf _ hf / 60.0.
	i _ hf truncated.  "integer part of hue"
	f _ hf fractionPart.         "fractional part of hue"
	p _ (1.0 - s) * v.
	q _ (1.0 - (s * f)) * v.
	t _ (1.0 - (s * (1.0 - f))) * v.

	0 = i ifTrue: [ ^ self setRed: v green: t blue: p ].
	1 = i ifTrue: [ ^ self setRed: q green: v blue: p ].
	2 = i ifTrue: [ ^ self setRed: p green: v blue: t ].
	3 = i ifTrue: [ ^ self setRed: p green: q blue: v ].
	4 = i ifTrue: [ ^ self setRed: t green: p blue: v ].
	5 = i ifTrue: [ ^ self setRed: v green: p blue: q ].

	self error: 'implementation error'.
! !

CompiledMethod makeSelector: #valueWithReceiver:arguments: privilaged: true!
!CompiledMethod methodsFor: 'evaluating' stamp: 'ls 8/11/2000 09:57'!
valueWithReceiver: aReceiver arguments: anArray 
	| selector receiverClass answer |
	selector _ !!Symbol new.
	receiverClass := !!ObjectInspector classOf: aReceiver.
	receiverClass addSelector: selector withMethod: self.
	[answer := aReceiver perform: selector withArguments: anArray]
		ensure: [receiverClass removeSelectorSimply: selector].
	^answer! !

ContextPart makeSelector: #printOn: privilaged: true!
!ContextPart methodsFor: 'printing' stamp: 'ls 8/15/2000 20:11'!
printOn: aStream 
	| selector class mclass |
	self method == nil ifTrue: [^ super printOn: aStream].
	selector _ 
		(class _ (!!ObjectInspector classOf: self receiver))
			selectorAtMethod: self method 
			setClass: [:c | mclass _ c].
	selector == #?
		ifTrue: 
			[aStream nextPut: $?; print: self method who.
			^self].
	aStream nextPutAll: class name.
	mclass == class 
		ifFalse: 
			[aStream nextPut: $(.
			aStream nextPutAll: mclass name.
			aStream nextPut: $)].
	aStream nextPutAll: '>>'.
	aStream nextPutAll: selector! !
ContextPart makeSelector: #isHandlerContext privilaged: true!
!ContextPart methodsFor: 'private-exceptions' stamp: 'ls 8/14/2000 12:01'!
isHandlerContext

	^self method == (!!BlockContext compiledMethodAt: #on:do:)
! !

DisplayScreenStandin makeSelector: #boundingBox privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 09:31'!
boundingBox
	^ 0@0 corner: form extent! !
DisplayScreenStandin makeSelector: #checkForNewScreenSize privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/16/2000 10:12'!
checkForNewScreenSize! !
DisplayScreenStandin makeSelector: #defaultBitBltClass privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/14/2000 18:25'!
defaultBitBltClass
	"Return the BitBlt version to use when I am active"
	^BitBlt! !
DisplayScreenStandin makeSelector: #defaultCanvasClass privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 18:53'!
defaultCanvasClass
	^FormCanvas! !
DisplayScreenStandin makeSelector: #defaultWarpBltClass privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 19:51'!
defaultWarpBltClass
	"Return the WarpBlt version to use when I am active"
	^WarpBlt! !
DisplayScreenStandin makeSelector: #deferUpdates: privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/12/2000 15:27'!
deferUpdates: boolean! !
DisplayScreenStandin makeSelector: #depth privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 19:12'!
depth
	^form depth! !
DisplayScreenStandin makeSelector: #forceDisplayUpdate privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/12/2000 14:10'!
forceDisplayUpdate
	! !
DisplayScreenStandin makeSelector: #forceToScreen: privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 08:56'!
forceToScreen: rect! !
DisplayScreenStandin makeSelector: #getCanvas privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/16/2000 09:51'!
getCanvas
	^FormCanvas on: form! !
DisplayScreenStandin makeSelector: #getCurrentMorphicWorld privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 18:31'!
getCurrentMorphicWorld
	^World! !
DisplayScreenStandin makeSelector: #morphicWorldAt: privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 09:25'!
morphicWorldAt: aPoint
	"getting one world to work will be nice by itself.... -lex"
	^World! !
DisplayScreenStandin makeSelector: #width privilaged: false!
!DisplayScreenStandin methodsFor: 'as yet unclassified' stamp: 'ls 8/15/2000 20:04'!
width
	^form width! !
DisplayScreenStandin makeSelector: #form: privilaged: false!
!DisplayScreenStandin methodsFor: 'initialize' stamp: 'ls 8/14/2000 21:47'!
form: form0
	form := form0! !

Exception makeSelector: #signal privilaged: true!
!Exception methodsFor: 'exceptionSignaler' stamp: 'ls 8/11/2000 09:45'!
signal
	"Signal the occurrence of an exceptional condition."

	| result |
	initialContext == nil ifTrue: [initialContext := thisContext sender].
	resignalException := nil.
	handlerContext := !!Exception findHandlerFor: self from: initialContext.
	handlerContext ifNil: [^self defaultAction].

	result := self handlerAction.
	^resignalException == nil
		ifTrue: [result]
		ifFalse: [resignalException signal]
! !

Exception class makeSelector: #findHandlerFor:from: privilaged: true!
!Exception class methodsFor: 'finding handler' stamp: 'ls 8/14/2000 12:01'!
findHandlerFor: exception from: startCtx
	"search for a handler for the given exception, starting from the given context"
	| ctx handler |
	ctx := startCtx.
	[ctx == nil]
		whileFalse:
			[ctx isHandlerContext
				ifTrue:
					[handler := ctx tempAt: 1. "the first argument"
						((handler handles: exception) and: [|block realBlock| block := ctx tempAt: 2. realBlock :=  (!!ObjectInspector realBlockFor: block). realBlock sender == nil])
							ifTrue: [^ctx]].
			ctx := ctx sender].
       ^nil

! !

IsolatedIsland makeSelector: #globalPool privilaged: false!
!IsolatedIsland methodsFor: 'setup' stamp: 'ls 6/29/2000 15:38'!
globalPool
	^globalPool! !
IsolatedIsland makeSelector: #classProxyFor: privilaged: true!
!IsolatedIsland methodsFor: 'lookups' stamp: 'ls 8/11/2000 10:05'!
classProxyFor: realClass
        ^classProxies at: realClass ifAbsentPut: [ !!RestrictedClass on: realClass ]
! !

MethodContext makeSelector: #cachesStack privilaged: true!
!MethodContext methodsFor: 'private-debugger' stamp: 'ls 8/15/2000 17:52'!
cachesStack
	| vuMethod |
	!!Processor doInSystemIsland: [
		vuMethod := (!!BlockContext compiledMethodAt: #valueUninterruptably) ].
	^self == vuMethod! !

MethodDictionary makeSelector: #removeKey:ifAbsent: privilaged: true!
!MethodDictionary methodsFor: 'removing' stamp: 'ls 8/14/2000 12:00'!
removeKey: key ifAbsent: errorBlock 
	"The interpreter might be using this MethodDict while
	this method is running!!  Therefore we perform the removal
	in a copy, and then atomically become that copy"
	| copy |
	copy _ self copy.
	copy removeDangerouslyKey: key ifAbsent: [^ errorBlock value].
	!!Smalltalk elementsExchangeIdentity: {self} with: {copy}! !
MethodDictionary makeSelector: #grow privilaged: true!
!MethodDictionary methodsFor: 'private' stamp: 'ls 8/11/2000 11:57'!
grow 
	| newSelf key |
	newSelf _ self species new: self basicSize.  "This will double the size"
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	!!Smalltalk 
		elementsExchangeIdentity: {self}
		with: {newSelf}
! !

Morph makeSelector: #wantsSteps privilaged: true!
!Morph methodsFor: 'stepping and presenter' stamp: 'ls 8/16/2000 11:15'!
wantsSteps
	"Return true if the receiver overrides the default Morph step method."
	"Details: Find first class in superclass chain that implements #step and return true if it isn't class Morph."

	| c |
	self isPartsDonor ifTrue: [^ false].
	self player wantsSteps ifTrue: [^ true].
	!!Processor doInSystemIsland: [
		c _ self class classThatUnderstands: #step. ].

	^ c ~= !!Morph! !
Morph makeSelector: #worldUnderCursor privilaged: false!
!Morph methodsFor: 'WiW support' stamp: 'ls 8/16/2000 17:42'!
worldUnderCursor

        "will ultimately allow one Hand to service multiple worlds"
        ^Display morphicWorldAt: Sensor cursorPoint
! !

BouncingAtomsMorph makeSelector: #wantsSteps privilaged: false!
!BouncingAtomsMorph methodsFor: 'stepping' stamp: 'ls 8/15/2000 20:13'!
wantsSteps
	^true! !

HandMorph makeSelector: #processEvents privilaged: false!
!HandMorph methodsFor: 'event handling' stamp: 'ls 8/15/2000 09:20'!
processEvents
	"Process user input events from the local input devices."

	| griddedPoint evt currentExtent |
	InputEvents ifNotNil: [ ^self processEventsInSandbox ].
	griddedPoint _ Sensor cursorPoint "- owner viewBox topLeft".
	gridOn ifTrue: [griddedPoint _ griddedPoint grid: grid].

	evt _ MorphicEvent new
		setMousePoint: griddedPoint
		buttons: Sensor primMouseButtons
		lastEvent: lastEvent
		hand: self.

	remoteConnections size > 0 ifTrue: [
		currentExtent _ self worldBounds extent.
		lastWorldExtent ~= currentExtent ifTrue: [
			self transmitEvent: (MorphicEvent newWorldExtent: currentExtent).
			lastWorldExtent _ currentExtent].
		self transmitEvent: evt].

	self handleEvent: evt.

	[Sensor keyboardPressed] whileTrue: [
		evt _ MorphicEvent new
			setKeyValue: Sensor keyboard asciiValue
			mousePoint: griddedPoint
			buttons: Sensor primMouseButtons
			hand: self.
		remoteConnections size > 0 ifTrue: [self transmitEvent: evt].
		self handleEvent: evt].
! !
HandMorph makeSelector: #processEventsInSandbox privilaged: false!
!HandMorph methodsFor: 'event handling' stamp: 'ls 8/15/2000 09:18'!
processEventsInSandbox
	| event |
	"process events passed in via the global InputEvents"
	[ event := InputEvents nextEventOrNil.  event notNil ] whileTrue: [
		self handleEvent: event ]! !
HandMorph makeSelector: #worldMenuBuilder privilaged: false!
!HandMorph methodsFor: 'world menu' stamp: 'ls 8/16/2000 10:26'!
worldMenuBuilder
        
        ^TheWorldMenu new 
                world: self worldUnderCursor 
                project: (self worldUnderCursor project ifNil: [Project ifNotNil: [ Project current] ])       "mvc??"
                hand: self 
! !

MorphicSandbox makeSelector: #displayExtent:depth: privilaged: false!
!MorphicSandbox methodsFor: 'initialization' stamp: 'ls 8/16/2000 10:11'!
displayExtent: displayExtent  depth: displayDepth
	display := NonHibernatingForm  extent: displayExtent depth: displayDepth.
	displayCanvas := FormCanvas on: display.
	events := OrderedCollection new.
	mutex := Semaphore forMutualExclusion.! !
MorphicSandbox makeSelector: #addEvent: privilaged: false!
!MorphicSandbox methodsFor: 'events' stamp: 'ls 6/28/2000 09:36'!
addEvent: anEvent
	"add an event to the event queue"
	mutex critical: [ events add: anEvent ].! !
MorphicSandbox makeSelector: #nextEvent privilaged: false!
!MorphicSandbox methodsFor: 'events' stamp: 'ls 8/15/2000 09:14'!
nextEvent
	"return the next outstanding events on the event queue"
	| eventToReturn |
	mutex critical: [
		events isEmpty ifTrue: [ ^nil ].
		eventToReturn := events removeFirst ].

	^eventToReturn! !
MorphicSandbox makeSelector: #pendingEvents privilaged: false!
!MorphicSandbox methodsFor: 'events' stamp: 'ls 6/28/2000 09:36'!
pendingEvents
	"return all outstanding events on the event queue, and empty the queue"
	| eventsToReturn |
	mutex critical: [
		events isEmpty ifTrue: [ ^#() ].
		eventsToReturn := events copy.
		events := OrderedCollection new. ].
	^eventsToReturn! !
MorphicSandbox makeSelector: #changeClipRect: privilaged: true!
!MorphicSandbox methodsFor: 'display' stamp: 'ls 8/14/2000 12:02'!
changeClipRect: newClipRect
	mutex critical: [  !!Processor activeProcess setIsland: nil during: [
		displayCanvas := !!FormCanvas on: display.
		newClipRect ifNotNil: [
			displayCanvas := displayCanvas copyClipRect: newClipRect ] ] ]! !
MorphicSandbox makeSelector: #currentCursor privilaged: false!
!MorphicSandbox methodsFor: 'display' stamp: 'ls 8/15/2000 17:08'!
currentCursor
	"return the cursor currently in use"
	^currentCursor! !
MorphicSandbox makeSelector: #displayCanvasDo: privilaged: true!
!MorphicSandbox methodsFor: 'display' stamp: 'ls 8/12/2000 15:22'!
displayCanvasDo: aBlock
	| ans |
	"lock the object and perform aBlock with argument a canvas on the display.  aBlock must have a reasonably short runtime, or else a deadlock can occur"
	mutex critical: [
		!!Processor activeProcess setIsland: nil during: [ ans := aBlock value: displayCanvas ] ].
	^ans! !
MorphicSandbox makeSelector: #displayDo: privilaged: false!
!MorphicSandbox methodsFor: 'display' stamp: 'ls 6/29/2000 13:16'!
displayDo: aBlock
	"lock the object and perform aBlock with argument the form representing the virtual display"
	^mutex critical: [
		aBlock value: display ].! !
MorphicSandbox makeSelector: #setCursor: privilaged: false!
!MorphicSandbox methodsFor: 'display' stamp: 'ls 8/15/2000 17:07'!
setCursor: newCursor
	currentCursor := newCursor! !

MorphicSandbox class makeSelector: #displayExtent:depth: privilaged: false!
!MorphicSandbox class methodsFor: 'instance creation' stamp: 'ls 6/28/2000 09:30'!
displayExtent: displayExtent  depth: displayDepth
	^super new 
		displayExtent: displayExtent  depth: displayDepth;
		yourself! !
MorphicSandbox class makeSelector: #classesForExample privilaged: false!
!MorphicSandbox class methodsFor: 'example' stamp: 'ls 8/21/2000 10:32'!
classesForExample
	"return a set of classes to use in #example"
	| classes |
	classes := { 
Magnitude. Character. Date. Month. Week. LookupKey. Association.  Number. Float. Fraction. Integer. LargePositiveInteger. LargeNegativeInteger. SmallInteger. Time. Date. DateAndTime.
Duration.
Float.
Collection. Bag. CharacterSet. SequenceableCollection.  ArrayedCollection.  Array.  Array2D. Bitmap. ByteArray. RunArray.  SoundBuffer.  String. Symbol.  Text.  WordArray. Heap. Interval.  TextLineInterval.  LinkedList. Semaphore.  OrderedCollection. SortedCollection. Set. Dictionary.  IdentityDictionary.  PluggableDictionary. IdentitySet. PluggableSet.
Stream. PositionableStream. ReadStream. WriteStream. ReadWriteStream. LimitedWriteStream.
NewParagraph. Exception. Object. Color. TranslucentColor. Random.
Exception. Error. MessageNotUnderstood. BlockCannotReturn.  ArithmeticError. FloatingPointException. EndOfStream. Halt. AssertionFailure.  ZeroDivide.  IllegalResumeAttempt.  Notification.
Cursor. CursorWithMask. Form. ColorForm.
WorldState.
Rectangle.
BitBlt. WarpBlt.
StandardScriptingSystem. Presenter. TheWorldMenu.
Canvas. FormCanvas. GrafPort.  EllipseMidpointTracer.
MorphicTransform.
Preferences. Utilities. StringHolder.
FreeCellStatistics. 
CharacterScanner. CompositionScanner. DisplayScanner.
StrikeFont. TextStyle }.

	"add most safe morph classes"
	classes := classes, (Morph withAllSubclasses select: [ :mc | ({LipsMorph. MatrixTransformMorph. WordGameLetterMorph} includes: mc) not and: [mc definesPrivilagedMethod not ]]) asArray.


	^classes!
]style[(17 37 8 1501)f1b,f1,f1LMorphicSandbox class example;,f1! !
MorphicSandbox class makeSelector: #example privilaged: false!
!MorphicSandbox class methodsFor: 'example' stamp: 'ls 8/21/2000 10:30'!
example
	| sandbox sandboxMorph world ba str island displayBits displayExtent displayDepth displayStandin classes proc x |
	"sets up and returns:

		a sandbox instance
		a simple morphic page
		a morph to view the sandbox contents
		a suspended process which can update the sandbox"

"create the sandbox"
sandbox := MorphicSandbox displayExtent: 300@200 depth: 16.
sandboxMorph := SandboxMorph new sandbox: sandbox.

"create some objects that will live in the sandbox"
world := PasteUpMorph new.
world color: Color gray.
world beWorldForProject: nil.
world viewBox: (0@0 extent: 300@200).

ba := BouncingAtomsMorph new.
ba extent: 100@100.
ba openInWorld: world.

str := FrameRateMorph new.
str position: 150@50.
str openInWorld: world.


"create an process context (island) for the sandbox"
island := IsolatedIsland new initialize.

"set some standard global variables on the island"
island setVariable: #CharacterRepository toValue: CharacterRepository inPool: nil.
island setVariable: #Sensor toValue: SensorStandin new inPool: nil.
island setVariable: #Display toValue: nil inPool: nil.
island setVariable: #StandardSystemClock toValue: StandardSystemClock inPool: nil.
island setVariable: #World toValue: world inPool: nil.
island setVariable: #Delay toValue: RestrictedDelayFactory new inPool: nil.
island setVariable: #Semaphore toValue: RestrictedSemaphoreFactory new inPool: nil.
island setVariable: #X toValue: 0 inPool: nil.
island setVariable: #InputEvents toValue: (SandboxEventSource new initialize: sandbox) inPool: nil.
island setVariable: #CursorInstaller toValue: (SandboxCursorInstaller new initialize: sandbox) inPool: nil.
island setVariable: #ScriptingSystem toValue: nil inPool: nil.



"set up a Display for the sandbox.  The form's bits will be shared between the sandbox and the outer world"
sandbox displayDo: [ :d | displayBits := d bits.  displayExtent := d extent.  displayDepth := d depth ].
displayExtent := nil safePointFor: displayExtent.
displayDepth := nil safeIntegerFor: displayDepth.
displayStandin := 	DisplayScreenStandin new form: 
		(NonHibernatingForm basicNew setExtent: displayExtent depth: displayDepth bits: displayBits).
Processor activeProcess setIsland: island during: [	Display := displayStandin ].


"add a bunch of classes and initialize them"
classes := self classesForExample.

classes do: [ :class |
		island setVariable: class name toValue: (island classProxyFor: class) inPool: nil.
		island addClassPoolFor: class.
   ]  .


classes do: [ :realclass |
		((ObjectInspector classOf: realclass) methodDict keys includes: #initialize)
		ifTrue: [
				| proxyClass |
				proxyClass := island classProxyFor: realclass.
				Utilities informUser: realclass name during: [
					Processor activeProcess setIsland: island during: [proxyClass initializeForSandbox] ] ] ].

"Text must be initialized specially"
island setVariable: #TextConstants toValue: Dictionary new inPool: nil.
island addPool: (island valueOfVariable: #TextConstants inPool: nil) named: #TextConstants.
Processor activeProcess setIsland: island during: [Text initialize].
island removeVariable: #TextConstants fromPool: nil.


proc := Process forBlock: [  Processor activeProcess setIsland: island during: [
	[true] whileTrue: [x := World. world doOneCycle ] ]. ].
proc priority: Processor userBackgroundPriority.


	^{sandbox. world.  sandboxMorph. proc}! !

MorphicSandboxCanvas makeSelector: #class privilaged: false!
!MorphicSandboxCanvas methodsFor: 'proxy restrictions' stamp: 'ls 6/28/2000 15:34'!
class
	^self weakClass! !
MorphicSandboxCanvas makeSelector: #clone privilaged: false!
!MorphicSandboxCanvas methodsFor: 'proxy restrictions' stamp: 'ls 6/28/2000 15:39'!
clone
	^self! !
MorphicSandboxCanvas makeSelector: #instVarAt: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'proxy restrictions' stamp: 'ls 6/28/2000 09:44'!
instVarAt: index
	^self notAllowed! !
MorphicSandboxCanvas makeSelector: #instVarAt:put: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'proxy restrictions' stamp: 'ls 6/28/2000 15:34'!
instVarAt: index put: anObject
	^self notAllowed! !
MorphicSandboxCanvas makeSelector: #shallowCopy privilaged: false!
!MorphicSandboxCanvas methodsFor: 'proxy restrictions' stamp: 'ls 6/28/2000 15:39'!
shallowCopy
	^self! !
MorphicSandboxCanvas makeSelector: #sandbox: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'initialization' stamp: 'ls 6/28/2000 15:39'!
sandbox: sandbox0
	sandbox ifNotNil: [
		^self error: 'should not be initialized twice' ].
	sandbox := sandbox0! !
MorphicSandboxCanvas makeSelector: #clipBy:during: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 15:50'!
clipBy: inputClipRect during: operation
	| clipRect savedClipRect |
	clipRect := self safeRectangleFor: inputClipRect.

	savedClipRect := self clipRect.
	sandbox changeClipRect: clipRect.
	operation value: self.
	sandbox changeClipRect: savedClipRect.! !
MorphicSandboxCanvas makeSelector: #clipRect privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 15:53'!
clipRect
	^sandbox displayCanvasDo: [ :c | c clipRect ]! !
MorphicSandboxCanvas makeSelector: #contentsOfArea: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 15:55'!
contentsOfArea: inputArea
	| area form |
	area := self safeRectangleFor: inputArea.
	form := Form extent: area depth: area.
	sandbox displayCanvasDo: [ :c | c contentsOfArea: area into: form ].
	^form! !
MorphicSandboxCanvas makeSelector: #depth privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 15:56'!
depth
	^sandbox displayCanvasDo: [ :c | c depth ]! !
MorphicSandboxCanvas makeSelector: #drawPolygon:color:borderWidth:borderColor: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:01'!
drawPolygon: inputVertices color: inputColor borderWidth: inputBorderWidth  borderColor: inputBorderColor
	| vertices color borderWidth borderColor |
	vertices := OrderedCollection new.
	inputVertices do: [ :inputVertex | vertices add: (self safePointFor: inputVertex) ].
	color := self safeColorFor: inputColor.
	borderWidth := self safeIntegerFor: inputBorderWidth.
	borderWidth < 0 ifTrue: [ ^self error: 'border width must be non-negative' ].
	borderColor := self safeColorFor: inputBorderColor.

	sandbox displayCanvasDo: [ :c |
		c drawPolygon: vertices color: color borderWidth: borderWidth borderColor: borderColor ].! !
MorphicSandboxCanvas makeSelector: #extent privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:01'!
extent
	^sandbox displayCanvasDo: [ :c | c extent ]! !
MorphicSandboxCanvas makeSelector: #fillOval:color:borderWidth:borderColor: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:02'!
fillOval: inputBounds color: inputColor borderWidth: inputBorderWidth borderColor: inputBorderColor
	| color borderWidth borderColor bounds |
	bounds := self safeRectangleFor: inputBounds.
	color := self safeColorFor: inputColor.
	borderWidth := self safeIntegerFor: inputBorderWidth.
	borderWidth < 0 ifTrue: [ ^self error: 'border width must be non-negative' ].
	borderColor := self safeColorFor: inputBorderColor.

	sandbox displayCanvasDo: [ :c |
		c fillOval: bounds color: color borderWidth: borderWidth borderColor: borderColor ].! !
MorphicSandboxCanvas makeSelector: #frameAndFillRectangle:fillColor:borderWidth:borderColor: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:22'!
frameAndFillRectangle: inputBounds fillColor: inputColor borderWidth: inputBorderWidth borderColor: inputBorderColor
	| color borderWidth borderColor bounds |
	bounds := self safeRectangleFor: inputBounds.
	color := self safeColorFor: inputColor.
	borderWidth := self safeIntegerFor: inputBorderWidth.
	borderWidth < 0 ifTrue: [ ^self error: 'border width must be non-negative' ].
	borderColor := self safeColorFor: inputBorderColor.

	sandbox displayCanvasDo: [ :c |
		c frameAndFillRectangle: bounds fillColor: color borderWidth: borderWidth borderColor: borderColor ].! !
MorphicSandboxCanvas makeSelector: #line:to:width:color: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 8/7/2000 18:30'!
line: inputPoint1 to: inputPoint2 width: inputWidth color: inputColor
	| point1 point2 width color |
	point1 := self safePointFor: inputPoint1.
	point2 := self safePointFor: inputPoint2.
	width := self safeIntegerFor: inputWidth.
	color := self safeColorFor: inputColor.

	sandbox displayCanvasDo: [ :c |
		c line: point1 to: point2 width: width color: color ].! !
MorphicSandboxCanvas makeSelector: #origin privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:05'!
origin
	^sandbox displayCanvasDo: [ :c | c origin ]! !
MorphicSandboxCanvas makeSelector: #paragraph:bounds:color: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:06'!
paragraph: paragraph bounds: bounds color: color
	^self paragraph2: paragraph bounds: bounds color: color! !
MorphicSandboxCanvas makeSelector: #showAt:invalidRects: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:07'!
showAt: pt invalidRects: updateRects
	self flag: #xxx.
	"wee need to take advantage of this information, eventually"! !
MorphicSandboxCanvas makeSelector: #text:bounds:font:color: privilaged: false!
!MorphicSandboxCanvas methodsFor: 'canvas commands' stamp: 'ls 6/28/2000 16:19'!
text: inputString bounds: inputBounds font: inputFont color: inputColor
	| string bounds color |
	self flag: #xxx.  "need to use the supplied font"
	string := self safeStringFor: inputString maxLength: 500.
	bounds := self safeRectangleFor: inputBounds.
	color := self safeColorFor: inputColor.

	sandbox displayCanvasDo: [ :c |
		c text: string bounds: bounds font: nil color: color ]! !

MorphicSandboxCanvas class makeSelector: #forSandbox: privilaged: false!
!MorphicSandboxCanvas class methodsFor: 'instance creation' stamp: 'ls 6/28/2000 16:21'!
forSandbox: sandbox
	^super new sandbox: sandbox! !

NonHibernatingForm makeSelector: #hibernate privilaged: false!
!NonHibernatingForm methodsFor: 'as yet unclassified' stamp: 'ls 8/16/2000 10:10'!
hibernate
	! !
NonHibernatingForm makeSelector: #unhibernate privilaged: false!
!NonHibernatingForm methodsFor: 'as yet unclassified' stamp: 'ls 8/16/2000 10:11'!
unhibernate
	! !

PasteUpMorph makeSelector: #pseudoDraw:on: privilaged: false!
!PasteUpMorph methodsFor: 'display' stamp: 'ls 8/14/2000 21:00'!
pseudoDraw: aRectangle on: aCanvas
	|  f |
	aCanvas clipBy: aRectangle during: [ :c|
		f _ self fillStyle.
		f isTranslucent ifTrue: [c fillColor: Color black].
		c fillRectangle: bounds fillStyle: f.
		turtleTrailsForm ifNotNil: [c paintImage: turtleTrailsForm at: 0@0].
	].
! !
PasteUpMorph makeSelector: #project privilaged: false!
!PasteUpMorph methodsFor: 'project' stamp: 'ls 8/16/2000 10:25'!
project
	"Find the project that owns me.  Not efficient to call this."

	^ Project ifNotNil: [ Project ofWorld: self ]! !

Preferences class makeSelector: #initializeForSandbox privilaged: false!
!Preferences class methodsFor: 'initialization' stamp: 'ls 8/15/2000 19:17'!
initializeForSandbox
	FlagDictionary := Dictionary new.
	self initializeParameters.! !

Process makeSelector: #setIsland:during: privilaged: true!
!Process methodsFor: 'islands' stamp: 'ls 8/15/2000 20:10'!
setIsland: newIsland  during: aBlock
	"change the current island during execution of aBlock"
	| savedIsland exception stack |
	savedIsland := island.
	island := newIsland.
	aBlock on: !!Exception do: [ :ex | 
		(!!ExceptionAboutToReturn handles: ex) ifTrue: [ ex pass ].
		exception := ex.  island := savedIsland.
		stack := (!!ObjectInspector instVarOf: exception at: 2) longStack. island := newIsland. ].
	island := savedIsland.
	exception ifNotNil: [ self error: 'exception happened' ].
! !

SandboxCursorInstaller makeSelector: #initialize: privilaged: false!
!SandboxCursorInstaller methodsFor: 'initialization' stamp: 'ls 8/15/2000 16:52'!
initialize: sandbox0
	sandbox ifNotNil: [ ^self error: 'already initialized' ].
	sandbox := sandbox0! !
SandboxCursorInstaller makeSelector: #installCursor: privilaged: false!
!SandboxCursorInstaller methodsFor: 'installing' stamp: 'ls 8/15/2000 17:10'!
installCursor: inputCursor
	| cursor |
	cursor := self safeCursorFor: inputCursor.
	sandbox setCursor: cursor! !
SandboxCursorInstaller makeSelector: #installCursor:withMask: privilaged: false!
!SandboxCursorInstaller methodsFor: 'installing' stamp: 'ls 8/15/2000 17:14'!
installCursor: inputCursor  withMask: inputMask
	inputCursor maskForm == inputMask ifTrue: [
		^self installCursor: inputCursor ].

	"should assemble a new cursor if the mask doesn't match the cursor... but this is odd usage!!"
	^self installCursor: inputCursor! !

SandboxEventSource makeSelector: #nextEventOrNil privilaged: false!
!SandboxEventSource methodsFor: 'events' stamp: 'ls 8/15/2000 09:13'!
nextEventOrNil
	"return the next event, or nil if none are available"
	^sandbox nextEvent! !
SandboxEventSource makeSelector: #initialize: privilaged: false!
!SandboxEventSource methodsFor: 'initialization' stamp: 'ls 8/15/2000 09:15'!
initialize: sandbox0
	sandbox ifNotNil: [ ^self error: 'already initialized' ].
	sandbox := sandbox0! !

SandboxMorph makeSelector: #sandbox: privilaged: false!
!SandboxMorph methodsFor: 'initialization' stamp: 'ls 6/29/2000 13:17'!
sandbox: sandbox0
	sandbox := sandbox0.
	self extent: (sandbox displayDo: [ :d | d extent ])! !
SandboxMorph makeSelector: #drawBorderOn: privilaged: false!
!SandboxMorph methodsFor: 'drawing' stamp: 'ls 6/29/2000 13:14'!
drawBorderOn: aCanvas
	aCanvas frameRectangle: self bounds width: 3 color: Color gray.! !
SandboxMorph makeSelector: #drawOn: privilaged: false!
!SandboxMorph methodsFor: 'drawing' stamp: 'ls 6/29/2000 13:13'!
drawOn: aCanvas
	sandbox displayDo: [ :d |
		aCanvas clipBy: self bounds during: [ :c |
			c image: d at: self position ] ].
	self drawBorderOn: aCanvas.! !
SandboxMorph makeSelector: #step privilaged: false!
!SandboxMorph methodsFor: 'stepping and presenter' stamp: 'ls 6/29/2000 13:18'!
step
	"check for necessary redraws"
	self invalidRect: self bounds! !
SandboxMorph makeSelector: #wantsSteps privilaged: false!
!SandboxMorph methodsFor: 'stepping and presenter' stamp: 'ls 8/16/2000 10:01'!
wantsSteps
	^true! !
SandboxMorph makeSelector: #handlesMouseDown: privilaged: false!
!SandboxMorph methodsFor: 'events' stamp: 'ls 8/15/2000 09:21'!
handlesMouseDown: evt
	^true! !
SandboxMorph makeSelector: #handlesMouseUp: privilaged: false!
!SandboxMorph methodsFor: 'events' stamp: 'ls 8/15/2000 09:22'!
handlesMouseUp: evt
	^true! !
SandboxMorph makeSelector: #mouseDown: privilaged: false!
!SandboxMorph methodsFor: 'events' stamp: 'ls 8/15/2000 09:21'!
mouseDown: evt
	self sendEvent: evt! !
SandboxMorph makeSelector: #mouseUp: privilaged: false!
!SandboxMorph methodsFor: 'events' stamp: 'ls 8/15/2000 09:22'!
mouseUp: evt
	self sendEvent: evt! !
SandboxMorph makeSelector: #sendEvent: privilaged: false!
!SandboxMorph methodsFor: 'events' stamp: 'ls 8/15/2000 09:21'!
sendEvent: evt
	sandbox addEvent: evt! !

SensorStandin makeSelector: #currentCursor privilaged: false!
!SensorStandin methodsFor: 'cursor' stamp: 'ls 8/16/2000 17:39'!
currentCursor
	^Cursor currentCursor! !
SensorStandin makeSelector: #currentCursor: privilaged: false!
!SensorStandin methodsFor: 'cursor' stamp: 'ls 8/16/2000 17:39'!
currentCursor: newCursor
	^Cursor currentCursor: newCursor! !
SensorStandin makeSelector: #cursorPoint privilaged: false!
!SensorStandin methodsFor: 'cursor' stamp: 'ls 8/16/2000 17:42'!
cursorPoint
	^0@0! !

StandardScriptingSystem class makeSelector: #initialize privilaged: false!
!StandardScriptingSystem class methodsFor: 'class initialization' stamp: 'ls 8/15/2000 18:43'!
initialize
	"StandardScriptingSystem initialize"
	"Sometimes this method is vacuously changed just to get it in a changeset so that its invocation will occur as part of an update"

	ScriptingSystem ifNil: [ ScriptingSystem := self new ].

	ScriptingSystem
		initStandardSlotInfo;
		initCategoryElementDictionary;
		initStandardScriptInfo;
		initializeSystemSlotDictionary;
		initializeHelpStrings! !
StandardScriptingSystem class makeSelector: #initializeForSandbox privilaged: false!
!StandardScriptingSystem class methodsFor: 'class initialization' stamp: 'ls 8/15/2000 19:00'!
initializeForSandbox
	self flag: #xxx.  "a hack to get the sandbox going"
	FormDictionary := Dictionary new.
	ScriptingSystem := self new.! !

TextMorph class makeSelector: #initialize privilaged: false!
!TextMorph class methodsFor: 'as yet unclassified' stamp: 'ls 6/29/2000 15:53'!
initialize	"TextMorph initialize"
	"Initialize constants shared by classes associated with text display."

	CaretForm _ (ColorForm extent: 16@5
					fromArray: #(2r001100e26 2r001100e26 2r011110e26 2r111111e26 2r110011e26)
					offset: -2@0)
					colors: (Array with: Color transparent with: NewParagraph new selectionColor).
! !

WorldState makeSelector: #drawWorld:submorphs:invalidAreasOn: privilaged: false!
!WorldState methodsFor: 'update cycle' stamp: 'ls 8/14/2000 21:00'!
drawWorld: aWorld submorphs: submorphs invalidAreasOn: aCanvas 
	"Redraw the damaged areas of the given canvas and clear the damage list. Return a collection of the areas that
were redrawn."
	| rectList i n mm morphs rects rectToFill remnants rect clipRect |

	rectList _ damageRecorder invalidRectsFullBounds: aWorld viewBox.
	damageRecorder reset.
	aWorld updateTrailsForm.
	n _ submorphs size.
	morphs _ OrderedCollection new: n*2.
	rects _ OrderedCollection new: n*2.
	rectList do: [:r |
		true
		ifTrue:
			["Experimental top-down drawing --
			Traverses top to bottom, stopping if the entire area is filled.
			If only a single rectangle remains, then continue with the reduced rectangle."
			rectToFill _ r.
			i _ 1.
			[rectToFill == nil or: [i > n]] whileFalse:
				[mm _ submorphs at: i.
				((mm fullBounds intersects: r) and: [mm visible]) ifTrue:
					[morphs addLast: mm.  rects addLast: rectToFill.
					remnants _ mm areasRemainingToFill: rectToFill.
					remnants size = 1 ifTrue: [rectToFill _ remnants first].
					remnants size = 0 ifTrue: [rectToFill _ nil]].
				i _ i+1].

			"Now paint from bottom to top, but using the reduced rectangles."
			rectToFill ifNotNil:
				[aWorld pseudoDraw: rectToFill on: aCanvas].
			clipRect := rectToFill.
			[morphs isEmpty] whileFalse:
				[(rect _ rects removeLast) == rectToFill ifFalse:
					[(rectToFill _ rect).
					clipRect := clipRect := rectToFill].
				aCanvas clipBy: clipRect during: [ :cc | morphs removeLast fullDrawOn: cc]. ].
			morphs reset.  rects reset]
		ifFalse: [aWorld pseudoDraw: r on: aCanvas.
				aCanvas clipBy: r during: [ cc |
					submorphs reverseDo: [:m | m fullDrawOn: cc]]]
		].
	^ rectList! !
WorldState makeSelector: #runStepMethodsIn: privilaged: false!
!WorldState methodsFor: 'stepping' stamp: 'ls 8/16/2000 17:28'!
runStepMethodsIn: aWorld
	"Run morph 'step' methods whose time has come. Purge any morphs that are no longer in this world.
	ar 3/13/1999: Remove buggy morphs from the step list so that they don't raise repeated errors."

	| now deletions wakeupTime morphToStep nextTime |
	stepList size = 0 ifTrue: [^ self].
	now _ Time millisecondClockValue.
	((now < lastStepTime) or: [(now - lastStepTime) > 5000])
		 ifTrue: [self adjustWakeupTimes].  "clock slipped"
	deletions _ nil.
	"Note: Put the following into an error handler to prevent errors happening on stepping"
	[stepList do: [:entry |
		wakeupTime _ entry at: 2.
		morphToStep _ entry at: 1.
		morphToStep world == aWorld
			ifTrue:
				[wakeupTime <= now
					ifTrue:
						[| numStepIntervals stepTime |
						morphToStep stepAt: now.
						stepTime := morphToStep stepTime max: 1.
						numStepIntervals := ((now - wakeupTime) / stepTime)   ceiling.
						nextTime := wakeupTime + (stepTime * numStepIntervals).
						entry at: 2 put: nextTime]]
			ifFalse:
				[deletions ifNil: [deletions _ OrderedCollection new].
				deletions addLast: morphToStep]]]
	 on: Error do:  [:ex |
		self stopStepping: morphToStep. "Stop this guy right now"
		morphToStep setProperty: #errorOnStep toValue: true. "Remember stepping"
		ex pass ].

	deletions ifNotNil:
		[deletions do: [:deletedM |
			self stopStepping: deletedM.
			deletedM stopStepping]].
	lastStepTime _ now! !
WorldState makeSelector: #assuredCanvas privilaged: false!
!WorldState methodsFor: 'canvas' stamp: 'ls 8/16/2000 09:50'!
assuredCanvas
true ifTrue: [ ^nil  ].
	DisplayCanvas ifNotNil: [
		"a global has been supplied for us to draw on; we should oblige"
		canvas == DisplayCanvas ifFalse: [
			self canvas: DisplayCanvas ].
		^canvas
	].

	(canvas isNil or: [(canvas extent ~= viewBox extent) or: [canvas form depth ~= Display depth]])
		ifTrue:
			["allocate a new offscreen canvas the size of the window"
			DisplayCanvas 
				ifNotNil: [ self canvas: DisplayCanvas ]
				ifNil: [ self canvas: (Display defaultCanvasClass extent: viewBox extent)] ].
	^ self canvas! !

TextMorph initialize!
StandardScriptingSystem initialize!

!SandboxMorph reorganize!
('initialization' sandbox:)
('drawing' drawBorderOn: drawOn:)
('stepping and presenter' step wantsSteps)
('events' handlesMouseDown: handlesMouseUp: mouseDown: mouseUp: sendEvent:)
!


!SandboxEventSource reorganize!
('events' nextEventOrNil)
('initialization' initialize:)
!

DisplayScreenStandin removeSelector: #diferUpdates:!
DisplayScreenStandin removeSelector: #worldUnderCursor!
