'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:59:41 am'!
"Change Set:		ObjectInspectorBase
Date:			25 May 2000
Author:			Lex Spoon

Allows inspecting an object from the outside"!

Object subclass: #ObjectInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sandbox'!

!ObjectInspector commentStamp: '<historical>' prior: 0!
A low-level way to analyze objects.  Methods in this object short-circuit straight to the VM.  This is useful when you really want to know something about an object, even if that object might be trying to hide something from you.!
InterpreterPlugin subclass: #ObjectInspectorPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sandbox'!
ObjectInspector class makeSelector: #classOf: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 16:31'!
classOf: anObject
	"return the real class of anObject"
	<primitive: 111>
	^self primitiveFailed! !
ObjectInspector class makeSelector: #digitOf:at:put: privilaged: false!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 17:26'!
digitOf: aLargeInteger at: digitNumber put: digit
	^self elementOf: aLargeInteger at: digitNumber put: digit! !
ObjectInspector class makeSelector: #elementOf:at: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 16:07'!
elementOf: object at: index
	<primitive: 60>
	self primitiveFailed! !
ObjectInspector class makeSelector: #elementOf:at:put: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 16:31'!
elementOf: anObject at: index  put: value
	"modify an indexed element of anObject"
	<primitive: 61>
	self primitiveFailed! !
ObjectInspector class makeSelector: #instVarOf:at: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 15:51'!
instVarOf: anObject  at: index
	<primitive: 73>
	^self primitiveFailed! !
ObjectInspector class makeSelector: #instVarOf:at:put: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 16:31'!
instVarOf: anObject  at: index  put: aValue
	"change an instance variable of anObject, without first consulting anObject about the idea"
	<primitive: 74>
	^self primitiveFailed! !
ObjectInspector class makeSelector: #replaceIn:from:to:with:startingAt: privilaged: true!
!ObjectInspector class methodsFor: 'inspecting' stamp: 'ls 8/17/2000 16:30'!
replaceIn: object from: targetStart to: targetEnd with: anotherObject startingAt: sourceStart
	"bulk modify the target object, even if the target object doesn't define any modification methods"
	<primitive: 105>
	self primitiveFailed! !
ObjectInspector class makeSelector: #realBlockFor: privilaged: true!
!ObjectInspector class methodsFor: 'unwrapping' stamp: 'ls 8/4/2000 16:30'!
realBlockFor: aBlock
	| answer |
	"return the actual BlockContext underlying aBlock.  Does the right thing if aBlock is a BlockContext or a RestrictedBlock"
	answer := (self classOf: aBlock) == !!BlockContext
		ifTrue: [ aBlock ]
		ifFalse: [ self instVarOf: aBlock at: 1 ].
	answer ifNil: [ !!Error signal: 'found a RestrictedBlock wrapping nil!!' ].
	^answer! !
ObjectInspector class makeSelector: #realClassFor: privilaged: true!
!ObjectInspector class methodsFor: 'unwrapping' stamp: 'ls 8/14/2000 12:48'!
realClassFor: aClass
	| |
	((self classOf: aClass) == !!RestrictedClass or: [ (self classOf: aClass) == !!ReallyRestrictedClass ])
	ifTrue: [
		^self instVarOf: aClass at: 1.
]
	ifFalse: [
		(self classOf: aClass) isMeta ifFalse: [ !!Error signal: 'a class is needed here' ].
		^aClass ].
! !

ObjectInspectorPlugin makeSelector: #classOf privilaged: false!
!ObjectInspectorPlugin methodsFor: 'inspecting' stamp: 'ls 6/1/2000 16:03'!
classOf
	| object class |
	self export: true.
	object _ interpreterProxy stackValue: 0.
	class _ interpreterProxy fetchClassOf: object.

	interpreterProxy pop: 2 thenPush: class.
! !
ObjectInspectorPlugin makeSelector: #instVarOfAt privilaged: false!
!ObjectInspectorPlugin methodsFor: 'inspecting' stamp: 'ls 5/25/2000 14:40'!
instVarOfAt	
	| index value object slotSize |
	self export: true.

	index _ interpreterProxy stackIntegerValue: 0.
	object _ interpreterProxy stackValue: 1.
	
	interpreterProxy failed not ifTrue: [
		slotSize := interpreterProxy slotSizeOf: object.
		(index < 1) | (slotSize < index) ifTrue: [ interpreterProxy primitiveFail ]. ].
	
	interpreterProxy failed not ifTrue: [
		value := interpreterProxy fetchPointer: index-1 ofObject: object ].

	interpreterProxy failed not
		ifTrue: [interpreterProxy pop: 3.
			interpreterProxy push: value].! !
ObjectInspectorPlugin makeSelector: #instVarOfAtPut privilaged: false!
!ObjectInspectorPlugin methodsFor: 'inspecting' stamp: 'ls 5/25/2000 14:42'!
instVarOfAtPut
	| index value object slotSize |
	self export: true.

	value _ interpreterProxy stackValue: 0.
	index _ interpreterProxy stackIntegerValue: 1.
	object _ interpreterProxy stackValue: 2.
	
	interpreterProxy failed not ifTrue: [
		slotSize := interpreterProxy slotSizeOf: object.
		(index < 1) | (slotSize < index) ifTrue: [ interpreterProxy primitiveFail ]. ].
	
	interpreterProxy failed not ifTrue: [
		interpreterProxy storePointer: index-1 ofObject: object withValue: value ].

	interpreterProxy failed not
		ifTrue: [interpreterProxy pop: 3 ].! !

