self halt. !

'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:23 am'!
RestrictedProxy subclass: #ReallyRestrictedClass
	instanceVariableNames: 'class '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sandbox-Proxies'!
ReallyRestrictedClass subclass: #RestrictedClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sandbox-Proxies'!
Behavior subclass: #TaggedBehavior
	instanceVariableNames: 'tag realLookupClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes'!

!TaggedBehavior commentStamp: '<historical>' prior: 0!
A behavior with no superclass and an empty method dictionary.  This is used to trick out the supered message-sending machinery, and it should not actually have any instances.  It has an extra field for remembering one value.  This is used by ReallyRestrictedClass>>doesNotUnderstand: to handle supered message sends--the "lookupClass" pointer in the relevant CompiledMethod is set to an instance of this class, and the tag is set to the real class the lookup should happen in.  The interpreter will fail the lookup and send doesNotUnderstand: back to the ReallyRestrictedClass, and the tag can be used to look up the next method....  -ls!
Object makeSelector: #class privilaged: true!
!Object methodsFor: 'class membership' stamp: 'ls 7/28/2000 17:57'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."
	^ !!Smalltalk currentIsland classProxyFor:  ( !!ObjectInspector classOf: self).! !
Object makeSelector: #isKindOf: privilaged: true!
!Object methodsFor: 'class membership' stamp: 'ls 8/14/2000 12:00'!
isKindOf: aClass 
	"Answer whether the class, aClass, is a superclass or class of the receiver."
	| myClass realClass |
	myClass := !!ObjectInspector classOf: self.
	realClass := !!ObjectInspector realClassFor: aClass.
	myClass == realClass
		ifTrue: [^true]
		ifFalse: [^myClass inheritsFrom: realClass]! !
Object makeSelector: #isMemberOf: privilaged: true!
!Object methodsFor: 'class membership' stamp: 'ls 8/15/2000 08:57'!
isMemberOf: aClass 
	"Answer whether the receiver is an instance of the class, aClass."

	^(!!ObjectInspector classOf: self) == (!!ObjectInspector realClassFor: aClass)! !

Behavior makeSelector: #new privilaged: false!
!Behavior methodsFor: 'instance creation' stamp: 'ls 7/20/2000 16:23'!
new
	"Answer a new instance of the receiver (which is a class) with no indexable variables. Fail if the class is indexable."
	"Essential Primitive. See Object documentation whatIsAPrimitive."

	^self basicNew! !
Behavior makeSelector: #new: privilaged: false!
!Behavior methodsFor: 'instance creation' stamp: 'ls 7/17/2000 15:12'!
new: anInteger 
	"Primitive. Answer an instance of the receiver (which is a class) with the 
	number of indexable variables specified by the argument, anInteger. Fail 
	if the class is not indexable or if the argument is not a positive Integer. 
	Essential. See Object documentation whatIsAPrimitive."

	^self basicNew: anInteger
! !

Message makeSelector: #lookupClass privilaged: false!
!Message methodsFor: 'accessing' stamp: 'ls 7/19/2000 13:17'!
lookupClass
	"if this message was used in a supered send, then return the class the super was compiled in.  Otherwise, return nil"
	^lookupClass! !

MethodDictionary makeSelector: #init: privilaged: true!
!MethodDictionary methodsFor: 'private' stamp: 'ls 8/9/2000 17:04'!
init: n
	"Initialize array to an array size of n"
	"reimplemented here so that hte binding to Array is a hard binding"
	array _ !!Array new: n.
	tally _ 0! !

PseudoClass makeSelector: #selectorIsPrivilaged: privilaged: false!
!PseudoClass methodsFor: 'security' stamp: 'ls 6/28/2000 14:47'!
selectorIsPrivilaged: aSelector
	^false! !

ReallyRestrictedClass makeSelector: #class privilaged: true!
!ReallyRestrictedClass methodsFor: 'proxy restrictions' stamp: 'ls 8/4/2000 15:48'!
class
	^self notAllowed  "Metaclass and ReallyRestrictdClass are too dangerous"! !
ReallyRestrictedClass makeSelector: #clone privilaged: false!
!ReallyRestrictedClass methodsFor: 'proxy restrictions' stamp: 'ls 8/4/2000 15:21'!
clone
	^self! !
ReallyRestrictedClass makeSelector: #instVarAt: privilaged: false!
!ReallyRestrictedClass methodsFor: 'proxy restrictions' stamp: 'ls 8/4/2000 15:21'!
instVarAt: index
	^self notAllowed! !
ReallyRestrictedClass makeSelector: #class: privilaged: false!
!ReallyRestrictedClass methodsFor: 'initialization' stamp: 'ls 6/28/2000 12:32'!
class: class0
	class ifNotNil: [
		^self error: 'already initialized' ].
	class := class0! !
ReallyRestrictedClass makeSelector: #name privilaged: false!
!ReallyRestrictedClass methodsFor: 'safe methods' stamp: 'ls 6/28/2000 12:32'!
name
	^class name! !
ReallyRestrictedClass makeSelector: #doesNotUnderstand: privilaged: true!
!ReallyRestrictedClass methodsFor: 'forwarding' stamp: 'ls 8/15/2000 08:59'!
doesNotUnderstand: aMessage
	| selector method implementingClass answer fakeClass taggedFakeClass lookupClass |
	!!Processor doInSystemIsland: [
		selector := aMessage selector.

		aMessage lookupClass == (ObjectInspector classOf: self)
			ifTrue: [ lookupClass := (ObjectInspector classOf: class) ]
			ifFalse: [ lookupClass := aMessage lookupClass realLookupClass superclass ].

		"find the class that implements the method"
		implementingClass :=  lookupClass classThatUnderstands: selector.
		implementingClass ifNil: [
			^self error: 'message not understood' ].

		"check that the selector is unprivilaged"
		(implementingClass selectorIsPrivilaged: selector) ifTrue: [
			^self error: 'selector is privilaged' ].

		"look up the method"
		method := implementingClass compiledMethodAt: selector ifAbsent: [
			^self error: 'message not understood' ].

	"check that the method doesn't access instance variables"
	method usesInstanceVariables ifTrue: [
		^self error: 'method uses instance variables' ].
		
		"copy it"
		method := method copy.

		"fix up the super-sending helper literal, if present"
		(method numLiterals > 0 and: [ 
			(method lastLiteral isMemberOf: Association) and: [
				method lastLiteral key isNil and: [
					method lastLiteral value == (ObjectInspector classOf: class) ] ] ]) ifTrue: [

			"replace it a fake class that only implements this method"
			taggedFakeClass := TaggedBehavior new.
			fakeClass := (Behavior new superclass: taggedFakeClass methodDictionary: MethodDictionary new format: 0).
			taggedFakeClass superclass: (ObjectInspector classOf: self).

			"tag the class with the proper lookup class"
			taggedFakeClass realLookupClass: implementingClass.

			method literalAt: method numLiterals put: (nil -> fakeClass) ]. ].

	"invoke it"
	answer :=  method valueWithReceiver: self arguments: aMessage arguments.
	^answer! !
ReallyRestrictedClass makeSelector: #error: privilaged: false!
!ReallyRestrictedClass methodsFor: 'as yet unclassified' stamp: 'ls 7/13/2000 14:52'!
error: msg
	^Error signal: msg! !
ReallyRestrictedClass makeSelector: #printOn: privilaged: false!
!ReallyRestrictedClass methodsFor: 'printing' stamp: 'ls 8/10/2000 17:08'!
printOn: stream
	stream nextPutAll: self name! !

ReallyRestrictedClass class makeSelector: #on: privilaged: false!
!ReallyRestrictedClass class methodsFor: 'instance creation' stamp: 'ls 7/13/2000 16:35'!
on: aClass
	^super new class: aClass! !

RestrictedClass makeSelector: #basicNew privilaged: false!
!RestrictedClass methodsFor: 'safe methods' stamp: 'ls 7/17/2000 12:10'!
basicNew
	^class basicNew! !
RestrictedClass makeSelector: #basicNew: privilaged: false!
!RestrictedClass methodsFor: 'safe methods' stamp: 'ls 7/17/2000 12:17'!
basicNew: size
	^class basicNew: size! !
RestrictedClass makeSelector: #name privilaged: false!
!RestrictedClass methodsFor: 'safe methods' stamp: 'ls 6/20/2000 13:17'!
name
	^class name! !

TaggedBehavior makeSelector: #initialize privilaged: false!
!TaggedBehavior methodsFor: 'as yet unclassified' stamp: 'ls 7/19/2000 16:39'!
initialize
	superclass := nil.
	format := 0.   "does it matter, if there are no instances of it? -ls"
	methodDict := MethodDictionary new.! !
TaggedBehavior makeSelector: #realLookupClass privilaged: false!
!TaggedBehavior methodsFor: 'as yet unclassified' stamp: 'ls 7/19/2000 16:40'!
realLookupClass
	"return the lookupClass that was stashed here"
	^realLookupClass! !
TaggedBehavior makeSelector: #realLookupClass: privilaged: false!
!TaggedBehavior methodsFor: 'as yet unclassified' stamp: 'ls 7/19/2000 16:40'!
realLookupClass: aClass
	"stash a class here, so it can be retrieved later"
	realLookupClass := aClass! !

TaggedBehavior class makeSelector: #new privilaged: false!
!TaggedBehavior class methodsFor: 'instance creation' stamp: 'ls 7/19/2000 16:40'!
new
	^self basicNew initialize! !

