'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:56:41 am'!
"Change Set:		colorRefact1
Date:			13 August 2000
Author:			Lex Spoon

Put named colors into a single class variable, instead of allocating one class variable for each"!

Object subclass: #Color
	instanceVariableNames: 'rgb cachedDepth cachedBitPattern '
	classVariableNames: 'Black Blue BlueShift Brown CachedColormaps ColorChart ColorNames ComponentMask ComponentMax Cyan DarkGray Gray GrayToIndexMap Green GreenShift HalfComponentMask HighLightBitmaps IndexedColors LightBlue LightBrown LightCyan LightGray LightGreen LightMagenta LightOrange LightRed LightYellow Magenta MaskingMap NamedColors Orange PaleBlue PaleBuff PaleGreen PaleMagenta PaleOrange PalePeach PaleRed PaleTan PaleYellow PureBlue PureCyan PureGreen PureMagenta PureRed PureYellow RandomStream Red RedShift TranslucentPatterns Transparent VeryDarkGray VeryLightGray VeryPaleRed VeryVeryDarkGray VeryVeryLightGray White Yellow '
	poolDictionaries: ''
	category: 'Graphics-Display Objects'!
ClassDescription makeSelector: #printMethodChunk:withPreamble:on:moveSource:toFile: privilaged: false!
!ClassDescription methodsFor: 'fileIn/Out' stamp: 'ls 6/5/2000 15:36'!
printMethodChunk: selector withPreamble: doPreamble on: outStream
		moveSource: moveSource toFile: fileIndex
	"Copy the source code for the method associated with selector onto the fileStream.  If moveSource true, then also set the source code pointer of the method."
	| preamble method oldPos newPos sourceFile endPos |
	"write out the privilage specification for the method"
	outStream nextChunkPut: (self name, ' makeSelector: ', selector storeString, ' privilaged: ', (self selectorIsPrivilaged: selector) storeString).

	doPreamble 
		ifTrue: [preamble _ self name , ' methodsFor: ' ,
					(self organization categoryOfElement: selector) asString printString]
		ifFalse: [preamble _ ''].
	method _ self methodDict at: selector.
	((method fileIndex = 0
		or: [(SourceFiles at: method fileIndex) == nil])
		or: [(oldPos _ method filePosition) = 0])
		ifTrue:
		["The source code is not accessible.  We must decompile..."
		preamble size > 0 ifTrue: [outStream cr; nextPut: $!!; nextChunkPut: preamble; cr].
		outStream nextChunkPut: (self decompilerClass new decompile: selector
											in: self method: method) decompileString]
		ifFalse:
		[sourceFile _ SourceFiles at: method fileIndex.
		sourceFile position: oldPos.
		preamble size > 0 ifTrue:    "Copy the preamble"
			[outStream copyPreamble: preamble from: sourceFile].
		"Copy the method chunk"
		newPos _ outStream position.
		outStream copyMethodChunkFrom: sourceFile.
		sourceFile skipSeparators.      "The following chunk may have ]style["
		sourceFile peek == $] ifTrue: [
			outStream cr; copyMethodChunkFrom: sourceFile].
		moveSource ifTrue:    "Set the new method source pointer"
			[endPos _ outStream position.
			method checkOKToAdd: endPos - newPos at: newPos.
			method setSourcePosition: newPos inFile: fileIndex]].
	preamble size > 0 ifTrue: [outStream nextChunkPut: ' '].
	^ outStream cr! !

Color class makeSelector: #OLDnamed:put: privilaged: false!
!Color class methodsFor: 'class initialization' stamp: 'ls 8/12/2000 14:45'!
OLDnamed: newName put: aColor
	"Add a new color to the list and create an access message and a class variable for it.  The name should start with a lowercase letter.  (The class variable will start with an uppercase letter.)  (Color colorNames) returns a list of all color names.  "
	| str cap sym accessor csym |
	(aColor isKindOf: self) ifFalse: [^ self error: 'not a Color'].
	str _ newName asString.
	sym _ str asSymbol.
	cap _ str capitalized.
	csym _ cap asSymbol.
	(self class canUnderstand: sym) ifFalse: [
		"define access message"
		accessor _ str, (String with: Character cr with: Character tab), 			'^', cap.
		self class compile: accessor
			classified: 'named colors'].
	(self classPool includesKey: csym) ifFalse: [
		self addClassVarName: cap].
	(ColorNames includes: sym) ifFalse: [
		ColorNames add: sym].
	^ self classPool at: csym put: aColor! !
Color class makeSelector: #addAccessorsForNamedColors privilaged: false!
!Color class methodsFor: 'class initialization' stamp: 'ls 8/12/2000 15:09'!
addAccessorsForNamedColors
	| accessor |
	"Add a new color to the list and create an access message and a class variable for it.  The name should start with a lowercase letter.  (The class variable will start with an uppercase letter.)  (Color colorNames) returns a list of all color names.  "

	NamedColors keysDo: [ :str |
		accessor _ 
			str, (String with: Character cr with: Character tab), 
			'^ NamedColors at: #', str.
self inform: accessor.
		self class compile: accessor classified: 'named colors']! !


Color class makeSelector: #named:put: privilaged: false!
!Color class methodsFor: 'class initialization' stamp: 'ls 8/12/2000 14:49'!
named: newName put: aColor
	"Add a new color to the list and create an access message and a class variable for it.  The name should start with a lowercase letter.  (The class variable will start with an uppercase letter.)  (Color colorNames) returns a list of all color names.  "

	NamedColors ifNil: [ NamedColors := Dictionary new ].
	NamedColors at: newName put: aColor.

	(ColorNames includes: newName) ifFalse: [
		ColorNames add: newName].
! !

Color initialize !

Color class makeSelector: #black privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
black
	^ NamedColors at: #black! !
Color class makeSelector: #blue privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
blue
	^ NamedColors at: #blue! !
Color class makeSelector: #brown privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
brown
	^ NamedColors at: #brown! !
Color class makeSelector: #cyan privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
cyan
	^ NamedColors at: #cyan! !
Color class makeSelector: #darkGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:09'!
darkGray
	^ NamedColors at: #darkGray! !
Color class makeSelector: #gray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
gray
	^ NamedColors at: #gray! !
Color class makeSelector: #green privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
green
	^ NamedColors at: #green! !
Color class makeSelector: #lightBlue privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightBlue
	^ NamedColors at: #lightBlue! !
Color class makeSelector: #lightBrown privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightBrown
	^ NamedColors at: #lightBrown! !
Color class makeSelector: #lightCyan privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightCyan
	^ NamedColors at: #lightCyan! !
Color class makeSelector: #lightGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightGray
	^ NamedColors at: #lightGray! !
Color class makeSelector: #lightGreen privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:09'!
lightGreen
	^ NamedColors at: #lightGreen! !
Color class makeSelector: #lightMagenta privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:09'!
lightMagenta
	^ NamedColors at: #lightMagenta! !
Color class makeSelector: #lightOrange privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightOrange
	^ NamedColors at: #lightOrange! !
Color class makeSelector: #lightRed privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
lightRed
	^ NamedColors at: #lightRed! !
Color class makeSelector: #lightYellow privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:09'!
lightYellow
	^ NamedColors at: #lightYellow! !
Color class makeSelector: #magenta privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:09'!
magenta
	^ NamedColors at: #magenta! !
Color class makeSelector: #orange privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
orange
	^ NamedColors at: #orange! !
Color class makeSelector: #paleBlue privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleBlue
	^ NamedColors at: #paleBlue! !
Color class makeSelector: #paleBuff privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleBuff
	^ NamedColors at: #paleBuff! !
Color class makeSelector: #paleGreen privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleGreen
	^ NamedColors at: #paleGreen! !
Color class makeSelector: #paleMagenta privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleMagenta
	^ NamedColors at: #paleMagenta! !
Color class makeSelector: #paleOrange privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleOrange
	^ NamedColors at: #paleOrange! !
Color class makeSelector: #palePeach privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
palePeach
	^ NamedColors at: #palePeach! !
Color class makeSelector: #paleRed privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleRed
	^ NamedColors at: #paleRed! !
Color class makeSelector: #paleTan privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleTan
	^ NamedColors at: #paleTan! !
Color class makeSelector: #paleYellow privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
paleYellow
	^ NamedColors at: #paleYellow! !
Color class makeSelector: #red privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
red
	^ NamedColors at: #red! !
Color class makeSelector: #transparent privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
transparent
	^ NamedColors at: #transparent! !
Color class makeSelector: #veryDarkGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
veryDarkGray
	^ NamedColors at: #veryDarkGray! !
Color class makeSelector: #veryLightGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
veryLightGray
	^ NamedColors at: #veryLightGray! !
Color class makeSelector: #veryPaleRed privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
veryPaleRed
	^ NamedColors at: #veryPaleRed! !
Color class makeSelector: #veryVeryDarkGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
veryVeryDarkGray
	^ NamedColors at: #veryVeryDarkGray! !
Color class makeSelector: #veryVeryLightGray privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
veryVeryLightGray
	^ NamedColors at: #veryVeryLightGray! !
Color class makeSelector: #white privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
white
	^ NamedColors at: #white! !
Color class makeSelector: #yellow privilaged: false!
!Color class methodsFor: 'named colors' stamp: 'ls 8/12/2000 15:10'!
yellow
	^ NamedColors at: #yellow! !

