'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:27:15 am'!
"Change Set:		delaySema1
Date:			14 August 2000
Author:			Lex Spoon

Make Delays and Semaphores work and be safe within a sandbox"!

RestrictedProxy subclass: #RestrictedDelay
	instanceVariableNames: 'realDelay duration '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!RestrictedDelay commentStamp: '<historical>' prior: 0!
A restricted version of Delay which allows the important parts but doesn't allow access to private parts.!
RestrictedProxy subclass: #RestrictedDelayFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!
RestrictedProxy subclass: #RestrictedSemaphore
	instanceVariableNames: 'realSemaphore '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!
RestrictedProxy subclass: #RestrictedSemaphoreFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Processes'!

!RestrictedSemaphoreFactory commentStamp: '<historical>' prior: 0!
A factory of restricted semaphores.  It responds to #new and #forMutualExclusion.!
RestrictedDelay makeSelector: #initialize: privilaged: true!
!RestrictedDelay methodsFor: 'initialization' stamp: 'ls 8/14/2000 17:26'!
initialize: inputDuration0
	| duration0 |
	duration0 := self safeIntegerFor: inputDuration0.
	
	duration ifNotNil: [ ^self error: 'already initialized' ].
	duration := duration0.! !
RestrictedDelay makeSelector: #wait privilaged: true!
!RestrictedDelay methodsFor: 'waiting' stamp: 'ls 8/14/2000 17:26'!
wait
	!!Processor doInSystemIsland: [
		(Delay forMilliseconds: duration) wait ]! !

RestrictedDelay class makeSelector: #forMilliseconds: privilaged: false!
!RestrictedDelay class methodsFor: 'instance creation' stamp: 'ls 8/14/2000 17:28'!
forMilliseconds: duration
	^self basicNew initialize: duration! !

RestrictedDelayFactory makeSelector: #forMilliseconds: privilaged: true!
!RestrictedDelayFactory methodsFor: 'making delays' stamp: 'ls 8/14/2000 17:34'!
forMilliseconds: inputMilliseconds
	| milliseconds |
	milliseconds := self safeIntegerFor: inputMilliseconds.
	milliseconds < 0 ifTrue: [ ^self error: 'delays must be positive' ].

	^!!RestrictedDelay forMilliseconds: inputMilliseconds! !
RestrictedDelayFactory makeSelector: #forSeconds: privilaged: false!
!RestrictedDelayFactory methodsFor: 'making delays' stamp: 'ls 8/14/2000 17:31'!
forSeconds: seconds
	^self forMilliseconds: (seconds * 1000)! !

RestrictedSemaphore makeSelector: #initialize: privilaged: true!
!RestrictedSemaphore methodsFor: 'initialization' stamp: 'ls 8/14/2000 13:32'!
initialize: realSemaphore0
	realSemaphore ifNotNil: [ ^self error: 'already initialized' ].
	(!!ObjectInspector classOf: realSemaphore0) == !!Semaphore ifFalse: [
		^self error: 'a semaphore is needed' ].
	realSemaphore := realSemaphore0! !
RestrictedSemaphore makeSelector: #signal privilaged: true!
!RestrictedSemaphore methodsFor: 'semaphore operations' stamp: 'ls 8/14/2000 13:34'!
signal
	!!Processor doInSystemIsland: [
		realSemaphore signal ].! !
RestrictedSemaphore makeSelector: #wait privilaged: true!
!RestrictedSemaphore methodsFor: 'semaphore operations' stamp: 'ls 8/14/2000 13:34'!
wait
	!!Processor doInSystemIsland: [
		realSemaphore wait ]! !
RestrictedSemaphore makeSelector: #waitTimeoutMSecs: privilaged: true!
!RestrictedSemaphore methodsFor: 'semaphore operations' stamp: 'ls 8/14/2000 13:44'!
waitTimeoutMSecs: inputMSecs
	"Wait on this semaphore for up to the given number of milliseconds, then timeout. It is up to the sender to determine the difference between the expected event and a timeout."
	| msecs |
	msecs := self safeIntegerFor: inputMSecs.
	 !!Processor doInSystemIsland: [
		realSemaphore waitTimeoutMSecs: msecs ]! !
RestrictedSemaphore makeSelector: #waitTimeoutSeconds: privilaged: false!
!RestrictedSemaphore methodsFor: 'semaphore operations' stamp: 'ls 8/14/2000 13:43'!
waitTimeoutSeconds: anInteger
	"Wait on this semaphore for up to the given number of seconds, then timeout. It is up to the sender to determine the difference between the expected event and a timeout."

	self waitTimeoutMSecs: anInteger * 1000.
! !

RestrictedSemaphore class makeSelector: #on: privilaged: false!
!RestrictedSemaphore class methodsFor: 'instance creation' stamp: 'ls 8/14/2000 13:45'!
on: aSemaphore
	^self basicNew initialize: aSemaphore! !

RestrictedSemaphoreFactory makeSelector: #forMutualExclusion privilaged: false!
!RestrictedSemaphoreFactory methodsFor: 'creating semaphores' stamp: 'ls 8/14/2000 13:54'!
forMutualExclusion
	^self new signal! !
RestrictedSemaphoreFactory makeSelector: #new privilaged: true!
!RestrictedSemaphoreFactory methodsFor: 'creating semaphores' stamp: 'ls 8/14/2000 13:55'!
new
	| semaphore |
	!!Processor doInSystemIsland: [
		semaphore := RestrictedSemaphore on: Semaphore new ].
	^semaphore! !

RestrictedSemaphoreFactory removeSelector: #class!
RestrictedSemaphoreFactory removeSelector: #clone!
RestrictedSemaphoreFactory removeSelector: #instVarAt:!
RestrictedSemaphoreFactory removeSelector: #instVarAt:put:!
RestrictedSemaphoreFactory removeSelector: #shallowCopy!
RestrictedSemaphore removeSelector: #class!
RestrictedSemaphore removeSelector: #clone!
RestrictedSemaphore removeSelector: #instVarAt:!
RestrictedSemaphore removeSelector: #instVarAt:put:!
RestrictedSemaphore removeSelector: #shallowCopy!
RestrictedDelayFactory removeSelector: #class!
RestrictedDelayFactory removeSelector: #clone!
RestrictedDelay removeSelector: #class!
RestrictedDelay removeSelector: #clone!
RestrictedDelay removeSelector: #instVarAt:!
RestrictedDelay removeSelector: #instVarAt:put:!
RestrictedDelay removeSelector: #shallowCopy!
