'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:59 am'!
ContextPart makeSelector: #isUnwindContext privilaged: true!
!ContextPart methodsFor: 'private-exceptions' stamp: 'ls 8/11/2000 10:05'!
isUnwindContext

	| m |
	^(m := self method) == (!!BlockContext compiledMethodAt: #ensure:)
		or: [m == (!!BlockContext compiledMethodAt: #ifCurtailed:)]! !

Exception makeSelector: #isNested privilaged: false!
!Exception methodsFor: 'signaledException' stamp: 'ls 6/9/2000 15:16'!
isNested
	"Determine whether the current exception handler is within the scope of another handler for the same exception."

	^(Exception findHandlerFor: self from: handlerContext sender) ~~ nil! !
Exception makeSelector: #outer privilaged: false!
!Exception methodsFor: 'signaledException' stamp: 'ls 6/9/2000 15:20'!
outer
	"Evaluate the enclosing exception action for the receiver and return."

	self isResumable
		ifTrue:
			[handlerContext := self class  findHandlerFor: self from: handlerContext sender.
			handlerContext == nil
				ifTrue: [self defaultAction]
				ifFalse: [self handlerAction]]
		ifFalse: [self pass]
! !
Exception makeSelector: #pass privilaged: true!
!Exception methodsFor: 'signaledException' stamp: 'ls 8/14/2000 12:02'!
pass
	"Yield control to the enclosing exception action for the receiver."

	handlerContext := !!Exception  findHandlerFor: self from: handlerContext sender.
	handlerContext == nil
		ifTrue:
			[self defaultAction.
			self isResumable
				ifTrue: [self resume]
				ifFalse: [!!IllegalResumeAttempt signal]]
		ifFalse: [self handlerAction]
! !
Exception makeSelector: #resignalAs: privilaged: true!
!Exception methodsFor: 'signaledException' stamp: 'ls 6/9/2000 15:33'!
resignalAs: replacementException
	"Signal an alternative exception in place of the receiver."
self flag: #xxx.  "This is really a headache to implement.  Is replacementException supposed to be an *instance* ?!!"
	^self error: 'this hasn''t been secured yet'.
"	thisContext unwindTo: initialContext.
	replacementException initialContext: initialContext.
	resignalException := replacementException"! !
Exception makeSelector: #resume: privilaged: true!
!Exception methodsFor: 'signaledException' stamp: 'ls 8/14/2000 12:01'!
resume: resumptionValue
	"Return the argument as the value of the message that signaled the receiver."


	| tc |
	self isResumable ifFalse: [!!IllegalResumeAttempt signal].
	tc := thisContext.
	tc unwindTo: initialContext.
	tc terminateTo: initialContext.
	^resumptionValue! !
Exception makeSelector: #retry privilaged: true!
!Exception methodsFor: 'signaledException' stamp: 'ls 6/8/2000 16:40'!
retry
	
"Abort an exception handler and re-evaluate its protected block."

	thisContext unwindTo: handlerContext.
	thisContext terminateTo: handlerContext.
	handlerContext restart! !
Exception makeSelector: #return: privilaged: true!
!Exception methodsFor: 'signaledException' stamp: 'ls 8/14/2000 12:01'!
return: returnValue
	"Return the argument as the value of the block protected by the active exception handler."

	| handlerHomeContext |
	handlerHomeContext := !!ExceptionAboutToReturn signal.
	initialContext unwindTo: handlerContext.
	thisContext terminateTo: handlerContext.
	handlerHomeContext == nil
		ifFalse: [handlerContext sender swapSender: handlerHomeContext].
	^returnValue! !
Exception makeSelector: #initialize privilaged: true!
!Exception methodsFor: 'exceptionBuilder' stamp: 'ls 7/20/2000 16:49'!
initialize
! !
Exception makeSelector: #description privilaged: true!
!Exception methodsFor: 'exceptionDescription' stamp: 'ls 8/14/2000 12:01'!
description
	
"Return a textual description of the exception."

	| desc mt |
	desc := (!!ObjectInspector classOf: self) name asString.
	^(mt := self messageText) == nil
		ifTrue: [desc]
		ifFalse: [desc, ': ', mt]! !
Exception makeSelector: #signal privilaged: true!
!Exception methodsFor: 'exceptionSignaler' stamp: 'ls 8/11/2000 09:45'!
signal
	"Signal the occurrence of an exceptional condition."

	| result |
	initialContext == nil ifTrue: [initialContext := thisContext sender].
	resignalException := nil.
	handlerContext := !!Exception findHandlerFor: self from: initialContext.
	handlerContext ifNil: [^self defaultAction].

	result := self handlerAction.
	^resignalException == nil
		ifTrue: [result]
		ifFalse: [resignalException signal]
! !
Exception makeSelector: #signal: privilaged: true!
!Exception methodsFor: 'exceptionSignaler' stamp: 'ls 6/8/2000 16:40'!
signal: signalerText
	"Signal the occurrence of an exceptional condition with a specified textual description."

	self messageText: signalerText.
	initialContext == nil ifTrue: [initialContext := thisContext sender].
	^self signal
! !

Error makeSelector: #devDefaultAction privilaged: false!
!Error methodsFor: 'private' stamp: 'ls 7/18/2000 13:31'!
devDefaultAction

	Debugger
		openContext: Debugger myContext
		label: self description
		contents: Debugger myContext shortStack! !
Error makeSelector: #isDevelopmentEnvironmentPresent privilaged: false!
!Error methodsFor: 'private' stamp: 'ls 6/7/2000 10:24'!
isDevelopmentEnvironmentPresent

	^true! !
Error makeSelector: #runtimeDefaultAction privilaged: false!
!Error methodsFor: 'private' stamp: 'ls 6/14/2000 15:42'!
runtimeDefaultAction
	"Dump the stack trace to a log file, then exit the program (image)."

	| file |
	file := FileStream newFileNamed: ('error', Utilities dateTimeSuffix, FileDirectory dot, 'log') asFileName.
	Smalltalk timeStamp: file.
	file nextPutAll: 'a serious error has occurred'.
	file close.
	Smalltalk snapshot: false andQuit: true! !

Exception class makeSelector: #new privilaged: false!
!Exception class methodsFor: 'exceptionInstantiator' stamp: 'ls 7/17/2000 12:14'!
new
	^self basicNew initialize! !
Exception class makeSelector: #signal privilaged: false!
!Exception class methodsFor: 'exceptionInstantiator' stamp: 'ls 7/17/2000 14:52'!
signal
	"Signal the occurrence of an exceptional condition."

	| ex |
	ex := self basicNew initialize.
	^ex signal! !
Exception class makeSelector: #signal: privilaged: false!
!Exception class methodsFor: 'exceptionInstantiator' stamp: 'ls 7/17/2000 14:52'!
signal: signalerText
	"TFEI - Signal the occurrence of an exceptional condition with a specified textual description."

	| ex |
	ex := self basicNew initialize.
	^ex signal: signalerText! !

ProgressInitiationException class makeSelector: #display:at:from:to:during: privilaged: false!
!ProgressInitiationException class methodsFor: 'signalling' stamp: 'ls 6/14/2000 14:12'!
display: aString at: aPoint from: minVal to: maxVal during: workBlock

	^self new
		display: aString at: aPoint from: minVal to: maxVal during: workBlock! !

ProjectEntryNotification class makeSelector: #signal: privilaged: false!
!ProjectEntryNotification class methodsFor: 'as yet unclassified' stamp: 'ls 6/14/2000 16:21'!
signal: aProject

	| ex |
	ex := self new.

	ex projectToEnter: aProject.
	^ex signal: 'Entering ',aProject printString! !

Warning makeSelector: #signal privilaged: true!
!Warning methodsFor: 'private-exceptionSignaler' stamp: 'ls 6/9/2000 15:20'!
signal
	"Signal the occurrence of an exceptional condition."
	"Warning is overriding this and marking it private in order to get around an apparent contradiction within the ANSI specification:
		Warning>>defaultAction must give the user the option to 'abort the computation'.
		Warning is resumable.
		Exception>>signal must return to its caller if it reaches a defaultAction in the case of a resumable exception.
		Therefore, Warning needs to invoke a handler action from its defaultAction; that handler action would seem to be return:, but according to the spec, 'It is erroneous to directly or indirectly send this message from within a #defaultAction method  to the receiver of the #defaultAction method.'

We have chosen to support the apparently intended behavior of Warning, at the expense of introducing a mildly unpleasant hack - in case of an unhandled Warning, we determine whether the user has elected to continue or not.  In the latter case, this process needs to terminate immediately, without returning to the sender of #signal.  To accomplish this, we nil out the sender on the call stack, and then use MethodContext>>cannotReturn: to open a notifier and allow the environment to continue in use."

	| result |
	initialContext == nil ifTrue: [initialContext := thisContext sender].
	resignalException := nil.
	handlerContext := self class findHandlerFor: self from: initialContext.

	handlerContext == nil
		ifTrue:
			[self defaultAction.
			"if user elected to continue the computation, execution did not reach this line"
			initialContext unwindTo: nil.
			thisContext terminateTo: nil]
		ifFalse:
			[result := self handlerAction.
			^resignalException == nil
				ifTrue: [result]
				ifFalse: [resignalException signal]]! !

