'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 4:26:35 pm'!
"Change Set:		immutLits1
Date:			17 August 2000
Author:			Lex Spoon

support for making literals be immutable"!

Array variableSubclass: #ReadOnlyArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Arrayed'!
SmallInteger makeSelector: #isReadOnly privilaged: false!
!SmallInteger methodsFor: 'testing' stamp: 'ls 8/18/2000 17:15'!
isReadOnly
	^true! !

!ReadOnlyArray commentStamp: '<historical>' prior: 0!
A read-only array may not be modified by messages sent to it.  It may, however, be modified by ObjectInspector.!
]style[(95 15 1)f1,f1LObjectInspector Definition;,f1!
LargeNegativeInteger variableByteSubclass: #ReadOnlyLargeNegativeInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!
LargePositiveInteger variableByteSubclass: #ReadOnlyLargePositiveInteger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Numbers'!
String variableByteSubclass: #ReadOnlyString
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Text'!

!ReadOnlyString commentStamp: 'ls 8/17/2000 17:13' prior: 0!
A string that may not be modified.!
Object makeSelector: #at: privilaged: false!
!Object methodsFor: 'accessing' stamp: 'ls 8/17/2000 13:50'!
at: index 
	^self basicAt: index! !
Object makeSelector: #at:put: privilaged: false!
!Object methodsFor: 'accessing' stamp: 'ls 8/17/2000 13:46'!
at: index put: value 
	^self basicAt: index put: value! !
Object makeSelector: #basicAt: privilaged: true!
!Object methodsFor: 'accessing' stamp: 'ls 8/17/2000 13:49'!
basicAt: index 
	"Primitive. Assumes receiver is indexable. Answer the value of an indexable element in the receiver. Fail if the argument index is not an Integer or is out of bounds. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 60>
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [self errorSubscriptBounds: index]
			ifFalse: [self error: (self class name) , 's are not indexable']].
	index isNumber
		ifTrue: [^self at: index asInteger]
		ifFalse: [self errorNonIntegerIndex]!
]style[(14 206 16 279)f1bcred;,f1,f1LObject class whatIsAPrimitive;,f1! !
Object makeSelector: #basicAt:put: privilaged: true!
!Object methodsFor: 'accessing' stamp: 'ls 8/21/2000 16:25'!
basicAt: index put: value 
	"Primitive. Assumes receiver is indexable. Store the argument value in the indexable element of the receiver indicated by index. Fail if the index is not an Integer or is out of bounds. Or fail if the value is not of the right type for this kind of collection. Answer the value that was stored. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 61>
	value isReadOnlyLargeInteger ifTrue: [
		^self basicAt: index put: value copy ].
	index isInteger ifTrue:
		[self class isVariable
			ifTrue: [(index >= 1 and: [index <= self size])
					ifTrue: [self errorImproperStore]
					ifFalse: [self errorSubscriptBounds: index]]
			ifFalse: [self error: (self class name) , 's are not indexable']].
	index isNumber
		ifTrue: [^self basicAt: index asInteger put: value]
		ifFalse: [self errorNonIntegerIndex]!
]style[(25 334 16 471)f1bcred;,f1,f1LObject class whatIsAPrimitive;,f1! !
Object makeSelector: #isReadOnly privilaged: false!
!Object methodsFor: 'testing' stamp: 'ls 8/18/2000 11:52'!
isReadOnly
	"return whether this object is read-only"
	^false! !
Object makeSelector: #isReadOnlyLargeInteger privilaged: false!
!Object methodsFor: 'testing' stamp: 'ls 8/21/2000 16:20'!
isReadOnlyLargeInteger
	"whether the receiver is a read-only large integer"
	^false! !
Object makeSelector: #errorNoModification privilaged: false!
!Object methodsFor: 'error handling' stamp: 'ls 8/17/2000 16:54'!
errorNoModification

	self error: 'receiver can not be modified.'! !

Array makeSelector: #asReadOnlyArray privilaged: false!
!Array methodsFor: 'converting' stamp: 'ls 8/17/2000 16:58'!
asReadOnlyArray
	"return a ReadOnlyArray with the same contents as the receiver"
	| ans |
	ans := ReadOnlyArray new: self size.
	ObjectInspector replaceIn: ans from: 1 to: self size with: self startingAt: 1.
	^ans! !

FileStream class makeSelector: #concreteStream privilaged: false!
!FileStream class methodsFor: 'concrete classes' stamp: 'ls 8/21/2000 11:22'!
concreteStream
	"Who should we really direct class queries to?  "
	^ StandardFileStream! !

Float makeSelector: #asReadOnlyNumber privilaged: false!
!Float methodsFor: 'converting' stamp: 'ls 8/18/2000 15:24'!
asReadOnlyNumber
	^self! !
Float makeSelector: #basicAt:put: privilaged: false!
!Float methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 17:13'!
basicAt: index put: value
	^self errorNoModification! !
Float makeSelector: #instVarAt:put: privilaged: false!
!Float methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 17:16'!
instVarAt: index put: value
	^self errorNoModification! !

Integer makeSelector: #asReadOnlyNumber privilaged: false!
!Integer methodsFor: 'converting' stamp: 'ls 8/18/2000 15:23'!
asReadOnlyNumber
	| ans |
	self isReadOnly ifTrue: [ "small integers are already readonly" ^self ].

	self negative
		ifTrue: [ ans := ReadOnlyLargeNegativeInteger new: self size ]
		ifFalse: [ ans := ReadOnlyLargePositiveInteger new: self size ].

	ObjectInspector replaceIn: ans from: 1 to: self size with: self startingAt: 1.
	^ans! !

LargePositiveInteger makeSelector: #copy privilaged: false!
!LargePositiveInteger methodsFor: 'copying' stamp: 'ls 8/21/2000 16:25'!
copy
	| result |
	result := self species new: self size.
	result replaceFrom: 1 to: self size with: self startingAt: 1.
	^result! !
LargePositiveInteger makeSelector: #digitAt:put: privilaged: false!
!LargePositiveInteger methodsFor: 'system primitives' stamp: 'ls 8/18/2000 14:29'!
digitAt: index put: value 
	"Primitive. Store the second argument (value) in the indexable field of 
	the receiver indicated by index. Fail if the value is negative or is larger 
	than 255. Fail if the index is not an Integer or is out of bounds. Answer 
	the value that was stored. Essential. See Object documentation 
	whatIsAPrimitive."

	^self basicAt: index put: value! !

ReadOnlyArray makeSelector: #basicAt:put: privilaged: false!
!ReadOnlyArray methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 16:55'!
basicAt: a put: b
	^self errorNoModification! !
ReadOnlyArray makeSelector: #instVarAt:put: privilaged: false!
!ReadOnlyArray methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 16:56'!
instVarAt: a put: b
	^self errorNoModification! !
ReadOnlyArray makeSelector: #replaceFrom:to:with:startingAt: privilaged: false!
!ReadOnlyArray methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 16:55'!
replaceFrom: a to: b with: c startingAt: d
	^self errorNoModification! !
ReadOnlyArray makeSelector: #storeOn: privilaged: false!
!ReadOnlyArray methodsFor: 'printing' stamp: 'ls 8/17/2000 17:12'!
storeOn: aStream
	super storeOn: aStream.
	aStream nextPutAll: ' asReadOnlyArray'.! !
ReadOnlyArray makeSelector: #species privilaged: false!
!ReadOnlyArray methodsFor: 'private' stamp: 'ls 8/18/2000 11:52'!
species
	^Array! !

ReadOnlyLargeNegativeInteger makeSelector: #basicAt:put: privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 15:17'!
basicAt: index put: value
	^self errorNoModification! !
ReadOnlyLargeNegativeInteger makeSelector: #instVarAt:put: privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 15:17'!
instVarAt: index put: value
	^self errorNoModification! !
ReadOnlyLargeNegativeInteger makeSelector: #replaceFrom:to:with:startingAt: privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 15:17'!
replaceFrom: start to: finish with: repl startingAt: replStart
	^self errorNoModification! !
ReadOnlyLargeNegativeInteger makeSelector: #isReadOnly privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'testing' stamp: 'ls 8/21/2000 16:15'!
isReadOnly
	^true! !
ReadOnlyLargeNegativeInteger makeSelector: #isReadOnlyLargeInteger privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'testing' stamp: 'ls 8/21/2000 16:19'!
isReadOnlyLargeInteger
	^true! !
ReadOnlyLargeNegativeInteger makeSelector: #species privilaged: false!
!ReadOnlyLargeNegativeInteger methodsFor: 'private' stamp: 'ls 8/21/2000 16:21'!
species
	^LargeNegativeInteger! !

ReadOnlyLargePositiveInteger makeSelector: #basicAt:put: privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 14:30'!
basicAt: index put: value
	^self errorNoModification! !
ReadOnlyLargePositiveInteger makeSelector: #instVarAt:put: privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 14:31'!
instVarAt: index put: value
	^self errorNoModification! !
ReadOnlyLargePositiveInteger makeSelector: #replaceFrom:to:with:startingAt: privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'disallowed methods' stamp: 'ls 8/18/2000 14:31'!
replaceFrom: start to: finish with: repl startingAt: replStart
	^self errorNoModification! !
ReadOnlyLargePositiveInteger makeSelector: #isReadOnly privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'testing' stamp: 'ls 8/21/2000 16:15'!
isReadOnly
	^true! !
ReadOnlyLargePositiveInteger makeSelector: #isReadOnlyLargeInteger privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'testing' stamp: 'ls 8/21/2000 16:19'!
isReadOnlyLargeInteger
	^true! !
ReadOnlyLargePositiveInteger makeSelector: #species privilaged: false!
!ReadOnlyLargePositiveInteger methodsFor: 'private' stamp: 'ls 8/21/2000 16:21'!
species
	^LargePositiveInteger! !

ScaledDecimal makeSelector: #asReadOnlyNumber privilaged: false!
!ScaledDecimal methodsFor: 'converting' stamp: 'ls 8/18/2000 17:44'!
asReadOnlyNumber
	^self! !
ScaledDecimal makeSelector: #setFraction:scale: privilaged: false!
!ScaledDecimal methodsFor: 'private' stamp: 'ls 8/18/2000 17:44'!
setFraction: fractionIn scale: scaleIn 
	"Private - Set the fraction to fractionIn and the total number of digits 
	used to represent the fraction part of the receiver, including trailing 
	zeroes, to the Integer scaleIn."
	fraction ifNotNil: [
		^self error: 'already initialized' ].
	fraction := fractionIn.
	scale := scaleIn! !

Scanner makeSelector: #xDigit privilaged: false!
!Scanner methodsFor: 'multi-character scans' stamp: 'ls 8/18/2000 15:28'!
xDigit
	"Form a number."

	tokenType _ #number.
	(aheadChar = 30 asCharacter and: [source atEnd
			and:  [source skip: -1. source next ~= 30 asCharacter]])
		ifTrue: [source skip: -1 "Read off the end last time"]
		ifFalse: [source skip: -2].
	token _ [(Number readFrom: source) asReadOnlyNumber] ifError: [:err :rcvr | self offEnd: err].
	self step; step! !


String makeSelector: #asReadOnlyString privilaged: false!
!String methodsFor: 'converting' stamp: 'ls 8/17/2000 17:42'!
asReadOnlyString
	"return a ReadOnlyString with the same contents as the receiver"
	| ans |
	ans := ReadOnlyString new: self size.
	self size = 0 ifTrue: [ ^ans ].
	ObjectInspector replaceIn: ans from: 1 to: self size with: self startingAt: 1.
	^ans! !

ReadOnlyString makeSelector: #at:put: privilaged: false!
!ReadOnlyString methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 17:08'!
at: a put: b
	^self errorNoModification! !
ReadOnlyString makeSelector: #basicAt:put: privilaged: false!
!ReadOnlyString methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 17:07'!
basicAt: a put: b
	^self errorNoModification! !
ReadOnlyString makeSelector: #byteAt:put: privilaged: false!
!ReadOnlyString methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 17:09'!
byteAt: a put: b
	^self errorNoModification! !
ReadOnlyString makeSelector: #instVarAt:put: privilaged: false!
!ReadOnlyString methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 17:10'!
instVarAt: anInteger put: anObject 
	^self errorNoModification! !
ReadOnlyString makeSelector: #replaceFrom:to:with:startingAt: privilaged: false!
!ReadOnlyString methodsFor: 'disallowed methods' stamp: 'ls 8/17/2000 17:10'!
replaceFrom: start to: stop with: replacement startingAt: repStart 
	^self errorNoModification! !
ReadOnlyString makeSelector: #species privilaged: false!
!ReadOnlyString methodsFor: 'private' stamp: 'ls 8/17/2000 17:33'!
species
	^String! !

Symbol makeSelector: #basicAt:put: privilaged: false!
!Symbol methodsFor: 'accessing' stamp: 'ls 8/17/2000 17:17'!
basicAt: anInteger put: anObject 
	"You cannot modify the receiver."

	self errorNoModification! !
Symbol makeSelector: #byteAt:put: privilaged: false!
!Symbol methodsFor: 'accessing' stamp: 'ls 8/17/2000 17:18'!
byteAt: anInteger put: anotherInteger
	"You cannot modify the receiver."

	self errorNoModification! !
Symbol makeSelector: #instVarAt:put: privilaged: false!
!Symbol methodsFor: 'accessing' stamp: 'ls 8/17/2000 17:19'!
instVarAt: index  put: value
	^self errorNoModification! !
Symbol makeSelector: #isReadOnly privilaged: false!
!Symbol methodsFor: 'testing' stamp: 'ls 8/18/2000 11:52'!
isReadOnly
	"return whether this object is read-only"
	^true! !

SystemDictionary makeSelector: #browsePrimitiveMethodsFor: privilaged: false!
!SystemDictionary methodsFor: 'browsing' stamp: 'ls 8/17/2000 16:53'!
browsePrimitiveMethodsFor: aClass
	"Smalltalk browsePrimitiveMethodsFor: Array"
	self browseMessageList: (self allPrimitiveMethodsFor: aClass) name: ('Primitives in ', aClass name)! !
SystemDictionary makeSelector: #allPrimitiveMethodsFor: privilaged: false!
!SystemDictionary methodsFor: 'retrieving' stamp: 'ls 8/17/2000 16:52'!
allPrimitiveMethodsFor: aClass
	"returns a list of primitive methods in aClass and its superclasses.  This is a fuzzy definition and might change in the future"
	| methods |
	methods := OrderedCollection new.
	aClass withAllSuperclassesDo: [ :class |
		class methodDict keys asSortedArray do: [ :selector |
			| method |
			method := class compiledMethodAt: selector.
			(method primitive > 0 and: [ method isQuick not ]) ifTrue: [
				methods add: (class name, ' ', selector) ] ] ].
	^methods! !

String removeSelector: #basicAt:put:!
Scanner removeSelector: #nextLiteral!
