'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:06 am'!
Object makeSelector: #doesNotUnderstand: privilaged: false!
!Object methodsFor: 'error handling' stamp: 'ls 7/5/2000 15:39'!
doesNotUnderstand: aMessage 
	"Handle the fact that there was an attempt to send the given message to 
	the receiver but the receiver does not understand this message 
	(typically sent from the machine when a message is sent to the 
	receiver and no method is defined for that selector)."


	MessageNotUnderstood new message: aMessage;
	 signal.
	^ aMessage sentTo: self! !

Behavior makeSelector: #compileAllFrom: privilaged: false!
!Behavior methodsFor: 'creating method dictionary' stamp: 'ls 7/5/2000 16:32'!
compileAllFrom: oldClass
	"Compile all the methods in the receiver's method dictionary.
	This validates sourceCode and variable references and forces
	all methods to use the current bytecode set"
	"ar 7/10/1999: Use oldClass selectors not self selectors"
	oldClass selectorsDo: [:sel | sel isEmpty ifFalse: [ self recompile: sel from: oldClass]. ].
	Smalltalk currentProjectDo: [:proj | proj compileAllIsolated: self from: oldClass].! !
Behavior makeSelector: #basicNew privilaged: true!
!Behavior methodsFor: 'instance creation' stamp: 'ls 8/14/2000 15:09'!
basicNew
	"Primitive. Answer an instance of the receiver (which is a class) with no 
	indexable variables. Fail if the class is indexable. Essential. See Object 
	documentation whatIsAPrimitive."

	<primitive: 70>
	self isVariable ifTrue: [ ^ self basicNew: 0 ].
	"space must be low"
	!!Smalltalk signalLowSpace.
	^ self basicNew  "retry if user proceeds"
! !
Behavior makeSelector: #basicNew: privilaged: true!
!Behavior methodsFor: 'instance creation' stamp: 'ls 8/14/2000 15:09'!
basicNew: anInteger 
	"Primitive. Answer an instance of the receiver (which is a class) with the 
	number of indexable variables specified by the argument, anInteger. Fail 
	if the class is not indexable or if the argument is not a positive Integer. 
	Essential. See Object documentation whatIsAPrimitive."

	<primitive: 71>
	self isVariable ifFalse: [
		self error: self printString, ' cannot have variable sized instances'].
	(anInteger isInteger and: [anInteger >= 0]) ifTrue: [
		"arg okay; space must be low"
		!!Smalltalk signalLowSpace.
		^ self basicNew: anInteger  "retry if user proceeds"
	].
	self primitiveFailed! !

ContextPart makeSelector: #selector privilaged: false!
!ContextPart methodsFor: 'debugger access' stamp: 'ls 8/14/2000 15:27'!
selector
	"Answer the selector of the method that created the receiver."

	^(ObjectInspector classOf: self receiver)
		selectorAtMethod: self method 
		setClass: [:ignored]! !
ContextPart makeSelector: #printOn: privilaged: true!
!ContextPart methodsFor: 'printing' stamp: 'ls 8/15/2000 20:11'!
printOn: aStream 
	| selector class mclass |
	self method == nil ifTrue: [^ super printOn: aStream].
	selector _ 
		(class _ (!!ObjectInspector classOf: self receiver))
			selectorAtMethod: self method 
			setClass: [:c | mclass _ c].
	selector == #?
		ifTrue: 
			[aStream nextPut: $?; print: self method who.
			^self].
	aStream nextPutAll: class name.
	mclass == class 
		ifFalse: 
			[aStream nextPut: $(.
			aStream nextPutAll: mclass name.
			aStream nextPut: $)].
	aStream nextPutAll: '>>'.
	aStream nextPutAll: selector! !

BlockContext makeSelector: #value: privilaged: true!
!BlockContext methodsFor: 'evaluating' stamp: 'ls 8/14/2000 15:08'!
value: arg 
	"Primitive. Evaluate the block represented by the receiver. Fail if the 
	block expects other than one argument or if the block is already being 
	executed. Optional. No Lookup. See Object documentation 
	whatIsAPrimitive."

	<primitive: 81>
	^self valueWithArguments: (!!Array with: arg)! !
BlockContext makeSelector: #value:value: privilaged: true!
!BlockContext methodsFor: 'evaluating' stamp: 'ls 8/14/2000 15:08'!
value: arg1 value: arg2 
	"Primitive. Evaluate the block represented by the receiver. Fail if the 
	block expects other than two arguments or if the block is already being 
	executed. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 81>
	^self valueWithArguments: (!!Array with: arg1 with: arg2)! !
BlockContext makeSelector: #value:value:value: privilaged: true!
!BlockContext methodsFor: 'evaluating' stamp: 'ls 8/14/2000 15:08'!
value: arg1 value: arg2 value: arg3 
	"Primitive. Evaluate the block represented by the receiver. Fail if the 
	block expects other than three arguments or if the block is already being 
	executed. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 81>
	^self valueWithArguments: 
		(!!Array
			with: arg1
			with: arg2
			with: arg3)! !
BlockContext makeSelector: #value:value:value:value: privilaged: true!
!BlockContext methodsFor: 'evaluating' stamp: 'ls 8/14/2000 15:08'!
value: arg1 value: arg2 value: arg3 value: arg4 
	"Primitive. Evaluate the block represented by the receiver. Fail if the 
	block expects other than three arguments or if the block is already being 
	executed. Optional. See Object documentation whatIsAPrimitive."

	<primitive: 81>
	^self valueWithArguments: 
		(!!Array
			with: arg1
			with: arg2
			with: arg3
			with: arg4)! !

Interval class makeSelector: #new privilaged: false!
!Interval class methodsFor: 'instance creation' stamp: 'ls 8/11/2000 11:00'!
new
	"Primitive. Create and answer with a new instance of the receiver
	(a class) with no indexable fields. Fail if the class is indexable. Override
	SequenceableCollection new. Essential. See Object documentation
	whatIsAPrimitive."

	^self basicNew! !

MethodContext makeSelector: #cachesStack privilaged: true!
!MethodContext methodsFor: 'private-debugger' stamp: 'ls 8/15/2000 17:52'!
cachesStack
	| vuMethod |
	!!Processor doInSystemIsland: [
		vuMethod := (!!BlockContext compiledMethodAt: #valueUninterruptably) ].
	^self == vuMethod! !

WorldState makeSelector: #assuredCanvas privilaged: false!
!WorldState methodsFor: 'canvas' stamp: 'ls 8/16/2000 09:50'!
assuredCanvas
true ifTrue: [ ^nil  ].
	DisplayCanvas ifNotNil: [
		"a global has been supplied for us to draw on; we should oblige"
		canvas == DisplayCanvas ifFalse: [
			self canvas: DisplayCanvas ].
		^canvas
	].

	(canvas isNil or: [(canvas extent ~= viewBox extent) or: [canvas form depth ~= Display depth]])
		ifTrue:
			["allocate a new offscreen canvas the size of the window"
			DisplayCanvas 
				ifNotNil: [ self canvas: DisplayCanvas ]
				ifNil: [ self canvas: (Display defaultCanvasClass extent: viewBox extent)] ].
	^ self canvas! !

