'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:40 am'!
"Change Set:		movePrims1
Date:			27 June 2000
Author:			Lex Spoon

Moves several primitives out of Object"!

Behavior makeSelector: #nextInstanceAfter: privilaged: true!
!Behavior methodsFor: 'enumerating' stamp: 'ls 6/27/2000 11:12'!
nextInstanceAfter: anObject
	"Answer the next instance after the receiver in the enumeration of all instances of this class. Fails if all instances have been enumerated"
	<primitive: 78>
	^nil! !

Interpreter makeSelector: #primitiveArrayBecome privilaged: false!
!Interpreter methodsFor: 'object access primitives' stamp: 'ls 6/27/2000 14:46'!
primitiveArrayBecome
	"We must flush the method cache here, to eliminate stale references
	to mutated classes and/or selectors."

	| arg1 arg2 |
	arg1 _ self stackTop.
	arg2 _ self stackValue: 1.
	self success: (self become: arg1 with: arg2 twoWay: true).
	self flushMethodCache.
	successFlag ifTrue: [ self pop: argumentCount].! !
Interpreter makeSelector: #primitiveArrayBecomeOneWay privilaged: false!
!Interpreter methodsFor: 'object access primitives' stamp: 'ls 6/27/2000 15:01'!
primitiveArrayBecomeOneWay
	"We must flush the method cache here, to eliminate stale references
	to mutated classes and/or selectors."

	| arg1 arg2 |
	arg2 _ self stackTop.
	arg1 _ self stackValue: 1.
	self success: (self become: arg1 with: arg2 twoWay: false).
	self flushMethodCache.
	successFlag ifTrue: [ self pop: argumentCount ].! !
Interpreter makeSelector: #primitiveNextInstance privilaged: false!
!Interpreter methodsFor: 'object access primitives' stamp: 'ls 6/27/2000 11:11'!
primitiveNextInstance
	| object instance |
	object _ self popStack.
	instance _ self instanceAfter: object.
	instance = nilObj
		ifTrue: [self unPop: 1. self primitiveFail]
		ifFalse: [self pop: argumentCount.  self push: instance]! !
Interpreter makeSelector: #primitiveNextObject privilaged: false!
!Interpreter methodsFor: 'object access primitives' stamp: 'ls 6/27/2000 10:37'!
primitiveNextObject
	"Return the object following the receiver in the heap. Return the SmallInteger zero when there are no more objects."
	"update: the object in question may be the first argument to the method"

	| object instance |
	object _ self popStack.
	self pop: argumentCount.   "if the object is an argument, discard the receiver"
	instance _ self accessibleObjectAfter: object.
	instance = nil
		ifTrue: [ self pushInteger: 0 ]
		ifFalse: [ self push: instance ].! !

SystemDictionary makeSelector: #nextObjectAfter: privilaged: true!
!SystemDictionary methodsFor: 'retrieving' stamp: 'ls 6/27/2000 10:39'!
nextObjectAfter: anObject
	<primitive: 139>
	self primitiveFailed! !
SystemDictionary makeSelector: #someObject privilaged: true!
!SystemDictionary methodsFor: 'retrieving' stamp: 'ls 6/27/2000 10:30'!
someObject
	"Primitive. Answer the first object in the enumeration of all
	 objects."

	<primitive: 138>
	self primitiveFailed.! !
SystemDictionary makeSelector: #elementsExchangeIdentity:with: privilaged: true!
!SystemDictionary methodsFor: 'memory space' stamp: 'ls 6/27/2000 15:19'!
elementsExchangeIdentity: array1  with: array2
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  At the same time, all pointers to the elements of otherArray are replaced by pointers to the corresponding elements of this array.  The identityHashes remain with the pointers rather than with the objects so that objects in hashed structures should still be properly indexed after the mutation."
	<primitive: 128>
	self primitiveFailed
! !
SystemDictionary makeSelector: #elementsForwardIdentity:with: privilaged: true!
!SystemDictionary methodsFor: 'memory space' stamp: 'ls 6/27/2000 15:17'!
elementsForwardIdentity: array1  with: array2
	"This primitive performs a bulk mutation, causing all pointers to the elements of this array to be replaced by pointers to the corresponding elements of otherArray.  The identityHashes remain with the pointers rather than with the objects so that the objects in this array should still be properly indexed in any existing hashed structures after the mutation."
	<primitive: 72>
	self primitiveFailed! !

