'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:15 am'!
"Change Set:		symbols
Date:			3 July 2000
Author:			Lex Spoon

This and hte next changeset make symbol and character generation available from within a sandobx.  The problem is interesting because both classes are intended to have unique instances for possible value, and thus global state must be involved at some point.

To make Symbols available, a mutex is added around critical Symbol accesses, and String>>asSymbol is marked privilaged.

Character>>value: is updated using a nicer design (lex doesn't have the stamina to do this for Symbols right now).  A global variable is added, CharacterRepository, which responds to #characterForAscii:.  Character class>>value: is updated to indirect through this global variable."!

Object subclass: #StandardCharacterRepository
	instanceVariableNames: 'characters '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Collections-Text'!
String variableByteSubclass: #Symbol
	instanceVariableNames: ''
	classVariableNames: 'OtherTable SelectorTables SingleCharSymbols TablesMutex '
	poolDictionaries: ''
	category: 'Collections-Text'!
Character makeSelector: #asSymbol privilaged: true!
!Character methodsFor: 'converting' stamp: 'ls 8/14/2000 12:00'!
asSymbol 
	"Answer a Symbol consisting of the receiver as the only element."

	^!!Symbol intern: self asString
! !

StandardCharacterRepository makeSelector: #initialize privilaged: false!
!StandardCharacterRepository methodsFor: 'initialization' stamp: 'ls 7/3/2000 17:17'!
initialize
	characters ifNotNil: [
		self error: 'already initialized!!' ].
	characters := (0 to: 255) collect: [ :ascii | Character value: ascii ]

! !
StandardCharacterRepository makeSelector: #characterForAscii: privilaged: false!
!StandardCharacterRepository methodsFor: 'lookups' stamp: 'ls 7/3/2000 17:16'!
characterForAscii: ascii
	^characters at: ascii+1! !

String makeSelector: #asSymbol privilaged: true. !
!String methodsFor: 'converting' stamp: 'ls 8/11/2000 17:22'!
asSymbol
	"Answer the unique Symbol whose characters are the characters of the 
	string."

	^!!Symbol intern: self
! !
String makeSelector: #stringhash privilaged: false!
!String methodsFor: 'private' stamp: 'ls 7/3/2000 15:36'!
stringhash
	| l m |
	(l _ m _ self size) <= 2
	  ifTrue:
		[l = 2
		  ifTrue: [m _ 3]
		  ifFalse:
			[l = 1
			  ifTrue: [^((self at: 1) asciiValue bitAnd: 127) * 106].
			^21845]].
	^(self at: 1) asciiValue * 48 + ((self at: (m - 1)) asciiValue + l)! !

String makeSelector: #hash privilaged: false!
!String methodsFor: 'comparing' stamp: 'ls 7/3/2000 15:36'!
hash

	^self stringhash! !
String makeSelector: #asSymbol privilaged: true!
Symbol class makeSelector: #initializeTablesMutex privilaged: false!
!Symbol class methodsFor: 'class initialization' stamp: 'ls 7/3/2000 15:55'!
initializeTablesMutex
	TablesMutex := Semaphore forMutualExclusion! !
Symbol class makeSelector: #realIntern: privilaged: true!
!Symbol class methodsFor: 'instance creation' stamp: 'ls 8/17/2000 16:46'!
realIntern: aString 
	"Answer a unique Symbol whose characters are those of aString."
	| ascii table mainTable index sym numArgs symbol lastNilIndex |
	#Collectn.
	"Changed 2000/04/08 For ANSI <sequenceReadableCollection> support."
	ascii := (aString at: 1) asciiValue.
	aString size = 1
		ifTrue: [ascii < 128 ifTrue: [^ !!SingleCharSymbols at: ascii + 1]].

	table := (ascii >= 97
				and: ["$a asciiValue"
					ascii <= 122 and: ["$z asciiValue"
						(numArgs := aString numArgs) >= 0]])
				ifTrue: [(mainTable := !!SelectorTables at: (numArgs + 1 min: !!SelectorTables size)) at: (index := ascii - 96)
					"($a asciiValue - 1)"]
				ifFalse: [(mainTable := !!OtherTable) at: (index := aString stringhash \\ !!OtherTable size + 1)].

	1 to: table size
		do: 
			[:i | 
			symbol := table at: i.
			symbol isNil
				ifTrue: [lastNilIndex := i]
				ifFalse: [(aString size = symbol size and: [symbol asString = aString])
						ifTrue: ["<- CHG"
							^ symbol]]].
	(aString isMemberOf: !!Symbol)
				ifTrue: [sym := aString
					"putting old symbol in new table"]
				ifFalse: [sym := (!!Symbol new: aString size).
						!!ObjectInspector replaceIn: sym from: 1 to: aString size with: aString startingAt: 1 ].
	"create a new one"
	lastNilIndex isNil
		ifTrue: [mainTable at: index put: (table copyWith: sym)]
		ifFalse: [table at: lastNilIndex put: sym].
	^ sym! !
Symbol class makeSelector: #forStringIfPresent: privilaged: false!
!Symbol class methodsFor: 'private' stamp: 'ls 7/3/2000 16:33'!
forStringIfPresent: aString
	"If aString has been interned, answer the relevant symbol.  Otherwise, answer nil"
	"TablesMutex should be held when this is called!!"

	| table ascii numArgs symbol |

	ascii := (aString at: 1) asciiValue.
	aString size = 1
		ifTrue: [ascii < 128
				ifTrue: 
					[^(SingleCharSymbols at: ascii + 1).]].

	table := (ascii >= 97
				and: ["$a asciiValue"
					ascii <= 122 and: ["$z asciiValue"
						(numArgs := aString numArgs) >= 0]])
				ifTrue: [(SelectorTables at: (numArgs + 1 min: SelectorTables size))
						at: ascii - 96
					"($a asciiValue - 1)"]
				ifFalse: [OtherTable at: aString stringhash \\ OtherTable size + 1].
	1 to: table size
		do: 
			[:i | 
			symbol := table at: i.
			(symbol notNil
				and: [aString size = symbol size and: [symbol asString = aString]])
				ifTrue: 
					["<- CHG"
					^symbol. ]].
	^ nil
! !


Symbol removeSelector: #stringhash  !


Symbol initializeTablesMutex.  !

self notify: 'okay bub, check it out' !
