'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:11 am'!
"Change Set:		symbols2
Date:			3 July 2000
Author:			Lex Spoon

Makes symbol intern-ing thread safe"

Smalltalk at: #CharacterRepository put: StandardCharacterRepository new initialize.
!

Character class makeSelector: #digitValue: privilaged: false!
!Character class methodsFor: 'instance creation' stamp: 'ls 7/3/2000 18:24'!
digitValue: x 
	"Answer the Character whose digit value is x. For example, answer $9 for 
	x=9, $0 for x=0, $A for x=10, $Z for x=35."

	| |
	^'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ' at: x + 1
! !
Character class makeSelector: #value: privilaged: false!
!Character class methodsFor: 'instance creation' stamp: 'ls 7/3/2000 17:18'!
value: anInteger 
	"Answer the Character whose value is anInteger."

	^CharacterRepository characterForAscii: anInteger! !

Symbol class makeSelector: #intern: privilaged: true!
!Symbol class methodsFor: 'instance creation' stamp: 'ls 8/11/2000 11:51'!
intern: aString 
	| sym |
	"Answer a unique Symbol whose characters are those of aString."
	!!TablesMutex critical: [
		sym := self realIntern: aString ].
	^sym! !
Symbol class makeSelector: #internCharacter: privilaged: true!
!Symbol class methodsFor: 'instance creation' stamp: 'ls 8/11/2000 11:51'!
internCharacter: aCharacter
	"Answer a unique Symbol of one character, the argument, aCharacter."

	| ascii |
	(ascii _ aCharacter asciiValue) < 128
		ifTrue: [^!!SingleCharSymbols at: ascii + 1].
	^self intern: (!!String with: aCharacter)
! !
Symbol class makeSelector: #hasInterned:ifTrue: privilaged: false!
!Symbol class methodsFor: 'private' stamp: 'ls 7/3/2000 16:34'!
hasInterned: aString ifTrue: symBlock 
	"Answer with false if aString hasnt been interned (into a Symbol),  
	otherwise supply the symbol to symBlock and return true."
	| sym |
	TablesMutex critical: [
		sym := self forStringIfPresent: aString ].
	sym ifNotNil: [ symBlock value: sym ].
	^sym notNil! !

