'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:56:59 am'!
"Change Set:		time
Date:			9 August 2000
Author:			Lex Spoon

Moves Time primitives into a separate SystemClock class, and creates a global instance under the name StandardSystemClock.  Primitive class methods are difficult to handle in the sandbox setup"!

Object subclass: #SystemClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-DateTime'!

!SystemClock commentStamp: '<historical>' prior: 0!
An object that interfaces with the system's clock(s).  The standard instance is StandardSystemClock.!
SystemClock makeSelector: #primCurrentTimeInto: privilaged: true!
!SystemClock methodsFor: 'queries' stamp: 'ls 8/9/2000 17:41'!
primCurrentTimeInto: anArray
	<primitive: 'primitiveCurrentTime' module: 'TimePlugin'>
	^nil! !
SystemClock makeSelector: #primMillisecondClock privilaged: true!
!SystemClock methodsFor: 'queries' stamp: 'ls 8/9/2000 17:31'!
primMillisecondClock
	"Primitive. Answer the number of milliseconds since the millisecond clock
	 was last reset or rolled over. Answer zero if the primitive fails.
	 Optional. See Object documentation whatIsAPrimitive."

	<primitive: 135>
	^ 0! !
SystemClock makeSelector: #primSecondsClock privilaged: true!
!SystemClock methodsFor: 'queries' stamp: 'ls 8/9/2000 17:26'!
primSecondsClock
	"Answer the number of seconds since 00:00 on the morning of
	 January 1, 1901 (a 32-bit unsigned number).
	 Essential. See Object documentation whatIsAPrimitive. "

	<primitive: 137>
	self primitiveFailed! !

"Postscript: initialize StandardSystemClock"
Smalltalk at: #StandardSystemClock put: SystemClock new.
!

