'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:58:16 am'!
"Change Set:		useCMFlag
Date:			22 June 2000
Author:			Lex Spoon

When a method is compiled, add a flag to the CompiledMethod specifying whether the method uses instance variables or not.

Note the interpreter should be translated and compiled after loading betterFlagInCM, and before loading this.  Otherwise, the VM will interpret the new flag as indicating a large primitive invocation."!

CompiledMethod class makeSelector: #toReturnConstant:trailerBytes: privilaged: false!
!CompiledMethod class methodsFor: 'instance creation' stamp: 'ls 6/22/2000 18:09'!
toReturnConstant: index trailerBytes: trailer
	"Answer an instance of me that is a quick return of the constant
	indexed in (true false nil -1 0 1 2)."

	^ self newBytes: 0 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 256 + index usesInstanceVariables: false

! !
CompiledMethod class makeSelector: #toReturnField:trailerBytes: privilaged: false!
!CompiledMethod class methodsFor: 'instance creation' stamp: 'ls 6/22/2000 18:09'!
toReturnField: field trailerBytes: trailer
	"Answer an instance of me that is a quick return of the instance variable 
	indexed by the argument, field."

	^ self newBytes: 0 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 264 + field usesInstanceVariables: true! !
CompiledMethod class makeSelector: #toReturnSelfTrailerBytes: privilaged: false!
!CompiledMethod class methodsFor: 'instance creation' stamp: 'ls 6/22/2000 18:09'!
toReturnSelfTrailerBytes: trailer
	"Answer an instance of me that is a quick return of the instance (^self)."

	^ self newBytes: 0 trailerBytes: trailer nArgs: 0 nTemps: 0 nStack: 0 nLits: 0 primitive: 256  usesInstanceVariables: false

! !

MethodNode makeSelector: #generate: privilaged: false!
!MethodNode methodsFor: 'code generation' stamp: 'ls 6/29/2000 14:09'!
generate: trailer 
	"The receiver is the root of a parse tree. Answer a CompiledMethod. The
	argument, trailer, is the references to the source code that is stored with 
	every CompiledMethod."

	| blkSize nLits stack strm nArgs method |
	self generate: trailer ifQuick: 
		[:m |  method _ m.
		method cacheTempNames: self tempNames.
		^ method].
	nArgs _ arguments size.
	blkSize _ block sizeForEvaluatedValue: encoder.
	literals _ encoder allLiterals.
	(nLits _ literals size) > 255
		ifTrue: [^self error: 'Too many literals referenced'].
	method _ CompiledMethod	"Dummy to allocate right size"
				newBytes: blkSize
				trailerBytes: trailer 
				nArgs: nArgs
				nTemps: encoder maxTemp
				nStack: 0
				nLits: nLits
				primitive: primitive
				usesInstanceVariables: self usesInstanceVariables.
	strm _ ReadWriteStream with: method.
	strm position: method initialPC - 1.
	stack _ ParseStack new init.
	block emitForEvaluatedValue: stack on: strm.
	stack position ~= 1 ifTrue: [^self error: 'Compiler stack
discrepancy'].

	strm position ~= (method size - trailer size) 
		ifTrue: [^self error: 'Compiler code size discrepancy'].
	method needsFrameSize: stack size.
	1 to: nLits do: [:lit | method literalAt: lit put: (literals at: lit)].
	method cacheTempNames: self tempNames.

	^ method
! !

