'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:27:21 am'!
"Change Set:		useTimePlugin
Date:			27 June 2000
Author:			Lex Spoon

Updates two locations to use the new time support:
	- Time class>>dateAndTimeNow
	- MailMessage>>dateStampNow

In my opinion, it would be nice to eventually transition all code to using hte ANSI DateAndTime class; in addition to being standard, it's nice to use!!
"!

!Celeste methodsFor: 'sending mail' stamp: 'ls 6/27/2000 17:20'!
queueMessageWithText: aStringOrText 
	"Queue a message to be sent later. The message is added to the database 
	and filed in the '.tosend.' category."
	| messageText id |
	messageText _ 'X-Mailer: ' , Celeste versionString , String cr , 'Date: ' , MailMessage dateStampNow, String cr.
	messageText _ messageText , aStringOrText asString.
	self requiredCategory: '.tosend.'.
	"queue the message"
	id _ mailDB addNewMessage: (MailMessage from: messageText).
	mailDB file: id inCategory: '.tosend.'.
	self category = '.tosend.' ifTrue: [self updateTOC]! !

!HtmlInput methodsFor: 'formatting' stamp: 'ls 6/30/2000 17:45'!
addImageButtonToFormatter: formatter
	"is it a submit button?"
	| formData imageUrl morph |
	(imageUrl _ self getAttribute: 'src') ifNil: [^self].
	formatter baseUrl
		ifNotNil: [imageUrl _ imageUrl asUrlRelativeTo: formatter baseUrl].

	morph _ DownloadingImageMorph new.
	morph defaultExtent: self imageExtent.
	morph altText: ((self getAttribute: 'alt') ifNil: [ '[image]' ]).
	morph url: imageUrl.

	value _ self getAttribute: 'name' default: 'Submit'.
	formData _ formatter currentFormData.
	morph
		on: #mouseUp
		send: #mouseUpEvent:linkMorph:formData:
		to: self
		withValue: formData.
	formatter addIncompleteMorph: morph
! !

!HtmlInput methodsFor: 'formatting' stamp: 'ls 6/30/2000 17:51'!
addToFormatter: formatter
	"is it a submit button?"
	(self type = 'submit' or: [ self type = 'image' ]) ifTrue: [
		formatter addMorph: ((PluggableButtonMorph on: formatter currentFormData getState: nil action: #submit) label: (self getAttribute: 'value' default: 'Submit')).
		^self ].

	self type = 'image'
		ifTrue: [^self addImageButtonToFormatter: formatter].

	(self type = 'text' or: [self type = 'password'])
		ifTrue: [^self addTextInputToFormatter: formatter].

	self type = 'hidden' ifTrue: [
		formatter currentFormData addInput: (HiddenInput name: self name  value: self defaultValue).
		^self ].

	self type = 'radio' ifTrue: [ 
		^self addRadioButtonToFormatter: formatter ].

	self type = 'checkbox' ifTrue: [ 
		^self addCheckBoxButtonToFormatter: formatter ].

	self type = 'file' ifTrue: [ 
		^self addFileInputToFormatter: formatter ].

	formatter addString: '[form input of type: ', self type, ']'.! !


!MailMessage class methodsFor: 'utilities' stamp: 'ls 6/30/2000 12:55'!
dateStampNow
	"Return the current date and time formatted as a email Date: line"
	"The result conforms to RFC822 with a long year, e.g.  'Thu, 18 Feb 1999 20:38:51'"
	| dateAndTime |
	dateAndTime := DateAndTime now.

	^	(dateAndTime dayOfWeekName copyFrom: 1 to: 3), 
		', ',
		(dateAndTime dayOfMonth printString),
		' ',
		(dateAndTime monthAbbreviation),
		' ',
		(dateAndTime year printString),
		' ',
		(dateAndTime hour24 printString),
		':',
		(dateAndTime minute printString),
		':',
		(dateAndTime second printString),
		' ',
		(dateAndTime offset negative ifTrue: [ '-' ] ifFalse:[ '+' ]),
		dateAndTime offset abs hours printString,
		(dateAndTime offset abs minutes printPaddedWith: $0 to: 2)


! !

!Time class methodsFor: 'instance creation'!
hours: hours minutes: minutes seconds: seconds
	^self new  hours: hours minutes: minutes seconds: seconds! !

!Time class methodsFor: 'general inquiries' stamp: 'ls 6/30/2000 13:20'!
dateAndTimeNow
	"Answer a two-element Array of (Date today, Time now)."
	| now |
	now := DateAndTime now.
	^Array
		with: (Date newDay: now dayOfMonth month: now month year: now year)
		with: (Time hours: now hour minutes: now minute seconds: now second)
! !

