'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:03 am'!
"Change Set:		valueWithReceiver
Date:			12 August 2000
Author:			Lex Spoon

Allow valueWithReceiver: to work within a sandbox"!

Behavior makeSelector: #addSelector:withMethod: privilaged: true!
!Behavior methodsFor: 'creating method dictionary' stamp: 'ls 8/11/2000 09:58'!
addSelector: selector withMethod: compiledMethod 
	"Add the message selector with the corresponding compiled method to the 
	receiver's method dictionary."

	| oldMethod |
	!!Processor activeProcess setIsland: nil during: [
		oldMethod _ self lookupSelector: selector.
		self methodDict at: selector put: compiledMethod.

		"Now flush Squeak's method cache, either by selector or by method"
		oldMethod == nil ifFalse: [oldMethod flushCache].
		selector flushCache ]! !
Behavior makeSelector: #removeSelectorSimply: privilaged: true!
!Behavior methodsFor: 'private' stamp: 'ls 8/14/2000 18:27'!
removeSelectorSimply: selector 
	"Assuming that the argument, selector (a Symbol), is a message selector 
	in my method dictionary, remove it and its method."

	| oldMethod |
	!!Processor doInSystemIsland: [
		oldMethod _ self methodDict at: selector ifAbsent: [^ self].
		self methodDict removeKey: selector.

		"Now flush Squeak's method cache, either by selector or by method"
		oldMethod flushCache.
		selector flushCache. ].! !

CompiledMethod makeSelector: #lastLiteral privilaged: false!
!CompiledMethod methodsFor: 'literals' stamp: 'ls 7/20/2000 16:27'!
lastLiteral
	^self literalAt: self numLiterals! !
CompiledMethod makeSelector: #valueWithReceiver:arguments: privilaged: true!
!CompiledMethod methodsFor: 'evaluating' stamp: 'ls 8/11/2000 09:57'!
valueWithReceiver: aReceiver arguments: anArray 
	| selector receiverClass answer |
	selector _ !!Symbol new.
	receiverClass := !!ObjectInspector classOf: aReceiver.
	receiverClass addSelector: selector withMethod: self.
	[answer := aReceiver perform: selector withArguments: anArray]
		ensure: [receiverClass removeSelectorSimply: selector].
	^answer! !

MethodDictionary makeSelector: #grow privilaged: true!
!MethodDictionary methodsFor: 'private' stamp: 'ls 8/11/2000 11:57'!
grow 
	| newSelf key |
	newSelf _ self species new: self basicSize.  "This will double the size"
	1 to: self basicSize do:
		[:i | key _ self basicAt: i.
		key == nil ifFalse: [newSelf at: key put: (array at: i)]].
	!!Smalltalk 
		elementsExchangeIdentity: {self}
		with: {newSelf}
! !

