'From Squeak2.9alpha of 13 June 2000 [latest update: #2447] on 21 August 2000 at 11:57:19 am'!
"Change Set:		pprintFixup
Date:			3 August 2000
Author:			Lex Spoon

Fixes up the pretty printer to cope with dynamic variables and with restricted blocks."!

Decompiler makeSelector: #cascadedMessageSend:selectorNode:rcvr:args: privilaged: false!
!Decompiler methodsFor: 'instruction decoding' stamp: 'ls 8/1/2000 11:47'!
cascadedMessageSend: selector selectorNode: selNode rcvr: rcvr0 args: args
	| rcvr msgNode messages |
	rcvr _ rcvr0.
"May actually be a cascade or an ifNil: for value."
			self willJumpIfFalse
				ifTrue: "= generated by a case macro"
					[selector == #= ifTrue:
						[" = signals a case statement..."
						statements addLast: args first.
						stack addLast: rcvr. "restore CascadeFlag"
						^ nil].
					selector == #== ifTrue:
						[" == signals an ifNil: for value..."
						stack removeLast; removeLast.
						rcvr _ stack removeLast.
						stack addLast: IfNilFlag;
							addLast: (constructor
								codeMessage: rcvr
								selector: selNode
								arguments: args).
						^ nil].
					self error: 'bad case: ', selector]
				ifFalse:
					[(self willJumpIfTrue and: [selector == #==]) ifTrue:
						[" == signals an ifNotNil: for value..."
						stack removeLast; removeLast.
						rcvr _ stack removeLast.
						stack addLast: IfNilFlag;
							addLast: (constructor
								codeMessage: rcvr
								selector: selNode
								arguments: args).
						^ nil].
					msgNode _ constructor codeCascadedMessage: selNode
									arguments: args].
			stack last == CascadeFlag
				ifFalse:
					["Last message of a cascade"
					statements addLast: msgNode.
					messages _ self popTo: stack removeLast.  "Depth saved by first dup"
					msgNode _ constructor
						codeCascade: stack removeLast
						messages: messages].

	^msgNode! !
Decompiler makeSelector: #send:super:numArgs: privilaged: false!
!Decompiler methodsFor: 'instruction decoding' stamp: 'ls 8/1/2000 12:20'!
send: selector super: superFlag numArgs: numArgs

	| args rcvr selNode msgNode |
	args _ Array new: numArgs.
	(numArgs to: 1 by: -1) do:
		[:i | args at: i put: stack removeLast].
	rcvr _ stack removeLast.
	superFlag ifTrue: [rcvr _ constructor codeSuper].
	(selector == #blockCopy: and: [self checkForBlock: rcvr])
		ifTrue: [ ^self ].

	selNode _ constructor codeAnySelector: selector.
	rcvr == CascadeFlag
		ifTrue:
			[msgNode _ self cascadedMessageSend: selector selectorNode: selNode rcvr: rcvr args: args]
		ifFalse:
			[(rcvr isBlock and: [ selector == #restrictedProxy ])
				ifTrue: [ msgNode _ rcvr ]
				ifFalse: [
					msgNode _ constructor
								codeMessage: rcvr
								selector: selNode
								arguments: args]. ].

	msgNode ifNotNil: [
		stack addLast: msgNode. ].! !

Decompiler class makeSelector: #recompilationTest privilaged: false!
!Decompiler class methodsFor: 'testing' stamp: 'ls 8/1/2000 12:00'!
recompilationTest
	"Decompiler recompilationTest"
	"test the decompiler by decompiling every method in the system, re-compiling them, and seeing if the result is the same"
	| failures |
	failures := OrderedCollection new.
	Smalltalk allBehaviorsDo: [ :behavior |
		behavior selectorsDo: [ :selector |
			| descript source method decompiled recompiled |
			descript := behavior name, ' ', selector.
			Utilities informUser: descript during: [
				source := behavior sourceCodeAt: selector.
				method := Compiler new compile: source in: behavior notifying: nil ifFail: [ nil ].
				method := method generate: #(0 0 0 0).
				decompiled := Decompiler new decompile: selector in: behavior method: method.
				recompiled := Compiler new compile: decompiled in: behavior notifying: nil ifFail: [
					failures add: descript.
					nil.
				].
				recompiled ifNotNil: [
					recompiled := recompiled generate: #(0 0 0 0).
					method = recompiled ifFalse: [ failures add: descript ].
				]
			] 
		].
	].

	^failures! !

ParseNode makeSelector: #isBlock privilaged: false!
!ParseNode methodsFor: 'testing' stamp: 'ls 8/1/2000 12:19'!
isBlock
	"whether the receiver is a block node"
	^false! !

BlockNode makeSelector: #isBlock privilaged: false!
!BlockNode methodsFor: 'testing' stamp: 'ls 8/1/2000 12:19'!
isBlock
	"whether the receiver is a block node"
	^true! !

DecompilerConstructor makeSelector: #codeDynamicVariableRcvr:selector:variableNameNode: privilaged: false!
!DecompilerConstructor methodsFor: 'constructor' stamp: 'ls 8/3/2000 16:32'!
codeDynamicVariableRcvr: smalltalkNode selector: selNode variableNameNode: argNode
! !
DecompilerConstructor makeSelector: #codeMessage:selector:arguments: privilaged: false!
!DecompilerConstructor methodsFor: 'constructor' stamp: 'ls 8/3/2000 18:08'!
codeMessage: receiver selector: selector arguments: arguments
	| symbol node messageNodeClass |
	symbol _ selector key.
	(node _ BraceNode new
			matchBraceWithReceiver: receiver
			selector: symbol
			arguments: arguments) ifNotNil: [^ node].
	(node _ self decodeIfNilWithReceiver: receiver
			selector: symbol
			arguments: arguments) ifNotNil: [^ node].

	(node _ self decodeDynamicVariableAssignmentWithReceiver: receiver selectorNode: selector arguments: arguments) ifNotNil: [
		^node ].



	(#( valueOfVariable:inPool:usingCache: setVariable:toValue:inPool:usingCache: )
		includes: symbol)
	ifTrue: [
		messageNodeClass := DynamicVariableNode. ]
	 ifFalse: [
		messageNodeClass := MessageNode ].

	^ messageNodeClass new
			receiver: receiver selector: selector
			arguments: arguments
			precedence: symbol precedence! !
DecompilerConstructor makeSelector: #decodeDynamicVariableAssignmentWithReceiver:selectorNode:arguments: privilaged: false!
!DecompilerConstructor methodsFor: 'constructor' stamp: 'ls 8/3/2000 18:08'!
decodeDynamicVariableAssignmentWithReceiver: receiver selectorNode: selector arguments: arguments
	"check if this is an assignment to a dynamic variable, and if so, return an appropriate AssignmentNode.  Note, the AssignmentNode will not be compilable, but it will pretty-print okay."
	selector key = #setVariable:toValue:inPool:usingCache: ifTrue: [
		| varNode |
		varNode := DynamicVariableNode new
			receiver: receiver
			selector: (self codeAnySelector: #valueOfVariable:inPool:usingCache:)
			arguments: {arguments first. arguments third.  arguments fourth }
			precedence: selector key precedence.
		^AssignmentNode new variable: varNode value: arguments second
	].

	^nil! !

DynamicVariableNode makeSelector: #printOn:indent: privilaged: false!
!DynamicVariableNode methodsFor: 'printing' stamp: 'ls 8/3/2000 18:02'!
printOn: stream indent: indentation
	selector key = #valueOfVariable:inPool:usingCache: ifTrue: [
		stream withStyleFor: #variable do: [
			stream nextPutAll: arguments first key].
		^self ].


	^super printOn: stream indent: indentation! !
DynamicVariableNode makeSelector: #printOn:indent:precedence: privilaged: false!
!DynamicVariableNode methodsFor: 'printing' stamp: 'ls 8/3/2000 18:02'!
printOn: stream indent: indentation precedence: prec
	selector key = #valueOfVariable:inPool:usingCache ifTrue: [
		^self printOn: stream indent: indentation ].

	^super printOn: stream indent: indentation precedence: prec! !

LeafNode makeSelector: #index privilaged: false!
!LeafNode methodsFor: 'accessing' stamp: 'ls 8/3/2000 17:08'!
index
	"return the index for this item"

	code < 256
		ifTrue:
			[code < 16
			ifTrue: [^code]
			ifFalse: [code < 32
					ifTrue: [^code - 16]
					ifFalse: [code < 96
							ifTrue: [^code \\ 32]
							ifFalse: [self error: 
									'Sends should be handled in SelectorNode']]]]
		ifFalse: 
			[^code \\ 256 ].

! !

VariableNode makeSelector: #isPseudoVariable privilaged: false!
!VariableNode methodsFor: 'testing' stamp: 'ls 8/3/2000 17:27'!
isPseudoVariable
	"whether we are one of self, super, nil, true, false, or thisContext"
	||
	^{LdSelf. LdSuper. LdNil. LdTrue. LdFalse. LdThisContext.} includes: code
! !
VariableNode makeSelector: #printOn:indent: privilaged: false!
!VariableNode methodsFor: 'printing' stamp: 'ls 8/3/2000 17:27'!
printOn: aStream indent: level 
	aStream withStyleFor: #variable
		do: [
			(self isPseudoVariable not and: [self type == LdLitIndType])
				ifTrue: [ aStream nextPut: $!! ].
			aStream nextPutAll: name].
! !

